
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 30 "core/cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#ifdef SHM_MEM
#include "shm_init.h"
#endif /* SHM_MEM */
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)




/* Line 189 of yacc.c  */
#line 242 "core/cfg.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     FORWARD = 258,
     FORWARD_TCP = 259,
     FORWARD_TLS = 260,
     FORWARD_SCTP = 261,
     FORWARD_UDP = 262,
     EXIT = 263,
     DROP = 264,
     RETURN = 265,
     BREAK = 266,
     LOG_TOK = 267,
     ERROR = 268,
     ROUTE = 269,
     ROUTE_REQUEST = 270,
     ROUTE_FAILURE = 271,
     ROUTE_ONREPLY = 272,
     ROUTE_REPLY = 273,
     ROUTE_BRANCH = 274,
     ROUTE_SEND = 275,
     ROUTE_EVENT = 276,
     EXEC = 277,
     SET_HOST = 278,
     SET_HOSTPORT = 279,
     SET_HOSTPORTTRANS = 280,
     PREFIX = 281,
     STRIP = 282,
     STRIP_TAIL = 283,
     SET_USERPHONE = 284,
     APPEND_BRANCH = 285,
     REMOVE_BRANCH = 286,
     CLEAR_BRANCHES = 287,
     SET_USER = 288,
     SET_USERPASS = 289,
     SET_PORT = 290,
     SET_URI = 291,
     REVERT_URI = 292,
     FORCE_RPORT = 293,
     ADD_LOCAL_RPORT = 294,
     FORCE_TCP_ALIAS = 295,
     UDP_MTU = 296,
     UDP_MTU_TRY_PROTO = 297,
     UDP4_RAW = 298,
     UDP4_RAW_MTU = 299,
     UDP4_RAW_TTL = 300,
     IF = 301,
     ELSE = 302,
     SET_ADV_ADDRESS = 303,
     SET_ADV_PORT = 304,
     FORCE_SEND_SOCKET = 305,
     SET_FWD_NO_CONNECT = 306,
     SET_RPL_NO_CONNECT = 307,
     SET_FWD_CLOSE = 308,
     SET_RPL_CLOSE = 309,
     SWITCH = 310,
     CASE = 311,
     DEFAULT = 312,
     WHILE = 313,
     CFG_SELECT = 314,
     CFG_RESET = 315,
     URIHOST = 316,
     URIPORT = 317,
     MAX_LEN = 318,
     SETFLAG = 319,
     RESETFLAG = 320,
     ISFLAGSET = 321,
     SETAVPFLAG = 322,
     RESETAVPFLAG = 323,
     ISAVPFLAGSET = 324,
     METHOD = 325,
     URI = 326,
     FROM_URI = 327,
     TO_URI = 328,
     SRCIP = 329,
     SRCPORT = 330,
     DSTIP = 331,
     DSTPORT = 332,
     TOIP = 333,
     TOPORT = 334,
     SNDIP = 335,
     SNDPORT = 336,
     SNDPROTO = 337,
     SNDAF = 338,
     PROTO = 339,
     AF = 340,
     MYSELF = 341,
     MSGLEN = 342,
     UDP = 343,
     TCP = 344,
     TLS = 345,
     SCTP = 346,
     WS = 347,
     WSS = 348,
     DEBUG_V = 349,
     FORK = 350,
     FORK_DELAY = 351,
     MODINIT_DELAY = 352,
     LOGSTDERROR = 353,
     LOGFACILITY = 354,
     LOGNAME = 355,
     LOGCOLOR = 356,
     LOGPREFIX = 357,
     LOGPREFIXMODE = 358,
     LOGENGINETYPE = 359,
     LOGENGINEDATA = 360,
     XAVPVIAPARAMS = 361,
     XAVPVIAFIELDS = 362,
     LISTEN = 363,
     ADVERTISE = 364,
     ALIAS = 365,
     SR_AUTO_ALIASES = 366,
     DNS = 367,
     REV_DNS = 368,
     DNS_TRY_IPV6 = 369,
     DNS_TRY_NAPTR = 370,
     DNS_SRV_LB = 371,
     DNS_UDP_PREF = 372,
     DNS_TCP_PREF = 373,
     DNS_TLS_PREF = 374,
     DNS_SCTP_PREF = 375,
     DNS_RETR_TIME = 376,
     DNS_RETR_NO = 377,
     DNS_SERVERS_NO = 378,
     DNS_USE_SEARCH = 379,
     DNS_SEARCH_FMATCH = 380,
     DNS_NAPTR_IGNORE_RFC = 381,
     DNS_CACHE_INIT = 382,
     DNS_USE_CACHE = 383,
     DNS_USE_FAILOVER = 384,
     DNS_CACHE_FLAGS = 385,
     DNS_CACHE_NEG_TTL = 386,
     DNS_CACHE_MIN_TTL = 387,
     DNS_CACHE_MAX_TTL = 388,
     DNS_CACHE_MEM = 389,
     DNS_CACHE_GC_INT = 390,
     DNS_CACHE_DEL_NONEXP = 391,
     DNS_CACHE_REC_PREF = 392,
     AUTO_BIND_IPV6 = 393,
     DST_BLST_INIT = 394,
     USE_DST_BLST = 395,
     DST_BLST_MEM = 396,
     DST_BLST_TTL = 397,
     DST_BLST_GC_INT = 398,
     DST_BLST_UDP_IMASK = 399,
     DST_BLST_TCP_IMASK = 400,
     DST_BLST_TLS_IMASK = 401,
     DST_BLST_SCTP_IMASK = 402,
     IP_FREE_BIND = 403,
     PORT = 404,
     STAT = 405,
     CHILDREN = 406,
     SOCKET_WORKERS = 407,
     ASYNC_WORKERS = 408,
     ASYNC_USLEEP = 409,
     ASYNC_NONBLOCK = 410,
     CHECK_VIA = 411,
     PHONE2TEL = 412,
     MEMLOG = 413,
     MEMDBG = 414,
     MEMSUM = 415,
     MEMSAFETY = 416,
     MEMJOIN = 417,
     MEMSTATUSMODE = 418,
     CORELOG = 419,
     SIP_WARNING = 420,
     SERVER_SIGNATURE = 421,
     SERVER_HEADER = 422,
     USER_AGENT_HEADER = 423,
     REPLY_TO_VIA = 424,
     LOADMODULE = 425,
     LOADPATH = 426,
     MODPARAM = 427,
     CFGENGINE = 428,
     MAXBUFFER = 429,
     SQL_BUFFER_SIZE = 430,
     USER = 431,
     GROUP = 432,
     CHROOT = 433,
     WDIR = 434,
     RUNDIR = 435,
     MHOMED = 436,
     DISABLE_TCP = 437,
     TCP_ACCEPT_ALIASES = 438,
     TCP_CHILDREN = 439,
     TCP_CONNECT_TIMEOUT = 440,
     TCP_SEND_TIMEOUT = 441,
     TCP_CON_LIFETIME = 442,
     TCP_POLL_METHOD = 443,
     TCP_MAX_CONNECTIONS = 444,
     TLS_MAX_CONNECTIONS = 445,
     TCP_NO_CONNECT = 446,
     TCP_SOURCE_IPV4 = 447,
     TCP_SOURCE_IPV6 = 448,
     TCP_OPT_FD_CACHE = 449,
     TCP_OPT_BUF_WRITE = 450,
     TCP_OPT_CONN_WQ_MAX = 451,
     TCP_OPT_WQ_MAX = 452,
     TCP_OPT_RD_BUF = 453,
     TCP_OPT_WQ_BLK = 454,
     TCP_OPT_DEFER_ACCEPT = 455,
     TCP_OPT_DELAYED_ACK = 456,
     TCP_OPT_SYNCNT = 457,
     TCP_OPT_LINGER2 = 458,
     TCP_OPT_KEEPALIVE = 459,
     TCP_OPT_KEEPIDLE = 460,
     TCP_OPT_KEEPINTVL = 461,
     TCP_OPT_KEEPCNT = 462,
     TCP_OPT_CRLF_PING = 463,
     TCP_OPT_ACCEPT_NO_CL = 464,
     TCP_OPT_ACCEPT_HEP3 = 465,
     TCP_CLONE_RCVBUF = 466,
     TCP_REUSE_PORT = 467,
     DISABLE_TLS = 468,
     ENABLE_TLS = 469,
     TLSLOG = 470,
     TLS_PORT_NO = 471,
     TLS_METHOD = 472,
     TLS_HANDSHAKE_TIMEOUT = 473,
     TLS_SEND_TIMEOUT = 474,
     SSLv23 = 475,
     SSLv2 = 476,
     SSLv3 = 477,
     TLSv1 = 478,
     TLS_VERIFY = 479,
     TLS_REQUIRE_CERTIFICATE = 480,
     TLS_CERTIFICATE = 481,
     TLS_PRIVATE_KEY = 482,
     TLS_CA_LIST = 483,
     DISABLE_SCTP = 484,
     ENABLE_SCTP = 485,
     SCTP_CHILDREN = 486,
     ADVERTISED_ADDRESS = 487,
     ADVERTISED_PORT = 488,
     DISABLE_CORE = 489,
     OPEN_FD_LIMIT = 490,
     SHM_MEM_SZ = 491,
     SHM_FORCE_ALLOC = 492,
     MLOCK_PAGES = 493,
     REAL_TIME = 494,
     RT_PRIO = 495,
     RT_POLICY = 496,
     RT_TIMER1_PRIO = 497,
     RT_TIMER1_POLICY = 498,
     RT_TIMER2_PRIO = 499,
     RT_TIMER2_POLICY = 500,
     MCAST_LOOPBACK = 501,
     MCAST_TTL = 502,
     MCAST = 503,
     TOS = 504,
     PMTU_DISCOVERY = 505,
     KILL_TIMEOUT = 506,
     MAX_WLOOPS = 507,
     PVBUFSIZE = 508,
     PVBUFSLOTS = 509,
     PVCACHELIMIT = 510,
     PVCACHEACTION = 511,
     HTTP_REPLY_PARSE = 512,
     VERSION_TABLE_CFG = 513,
     VERBOSE_STARTUP = 514,
     ROUTE_LOCKS_SIZE = 515,
     CFG_DESCRIPTION = 516,
     SERVER_ID = 517,
     KEMI = 518,
     ONSEND_ROUTE_CALLBACK = 519,
     REPLY_ROUTE_CALLBACK = 520,
     EVENT_ROUTE_CALLBACK = 521,
     MAX_RECURSIVE_LEVEL = 522,
     MAX_BRANCHES_PARAM = 523,
     LATENCY_CFG_LOG = 524,
     LATENCY_LOG = 525,
     LATENCY_LIMIT_DB = 526,
     LATENCY_LIMIT_ACTION = 527,
     MSG_TIME = 528,
     ONSEND_RT_REPLY = 529,
     FLAGS_DECL = 530,
     AVPFLAGS_DECL = 531,
     ATTR_MARK = 532,
     SELECT_MARK = 533,
     ATTR_FROM = 534,
     ATTR_TO = 535,
     ATTR_FROMURI = 536,
     ATTR_TOURI = 537,
     ATTR_FROMUSER = 538,
     ATTR_TOUSER = 539,
     ATTR_FROMDOMAIN = 540,
     ATTR_TODOMAIN = 541,
     ATTR_GLOBAL = 542,
     ADDEQ = 543,
     SUBST = 544,
     SUBSTDEF = 545,
     SUBSTDEFS = 546,
     EQUAL = 547,
     LOG_OR = 548,
     LOG_AND = 549,
     BIN_OR = 550,
     BIN_AND = 551,
     BIN_XOR = 552,
     BIN_LSHIFT = 553,
     BIN_RSHIFT = 554,
     STRDIFF = 555,
     STREQ = 556,
     INTDIFF = 557,
     INTEQ = 558,
     MATCH = 559,
     DIFF = 560,
     EQUAL_T = 561,
     LTE = 562,
     GTE = 563,
     LT = 564,
     GT = 565,
     MINUS = 566,
     PLUS = 567,
     MODULO = 568,
     SLASH = 569,
     STAR = 570,
     BIN_NOT = 571,
     UNARY = 572,
     NOT = 573,
     DEFINED = 574,
     STRCAST = 575,
     INTCAST = 576,
     DOT = 577,
     STRLEN = 578,
     STREMPTY = 579,
     NUMBER = 580,
     ID = 581,
     NUM_ID = 582,
     STRING = 583,
     IPV6ADDR = 584,
     PVAR = 585,
     AVP_OR_PVAR = 586,
     EVENT_RT_NAME = 587,
     COMMA = 588,
     SEMICOLON = 589,
     RPAREN = 590,
     LPAREN = 591,
     LBRACE = 592,
     RBRACE = 593,
     LBRACK = 594,
     RBRACK = 595,
     CR = 596,
     COLON = 597
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 198 "core/cfg.y"

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;



/* Line 214 of yacc.c  */
#line 641 "core/cfg.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 653 "core/cfg.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  451
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11735

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  343
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  889
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1660

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   597

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    13,    15,    17,    19,
      21,    23,    24,    27,    28,    31,    33,    34,    37,    38,
      41,    42,    45,    47,    49,    51,    53,    55,    57,    61,
      65,    67,    69,    71,    73,    75,    77,    79,    81,    83,
      85,    87,    89,    91,    93,    95,    97,   101,   105,   111,
     115,   117,   121,   125,   131,   135,   137,   140,   142,   145,
     148,   151,   153,   157,   159,   163,   165,   167,   170,   173,
     175,   179,   181,   185,   189,   193,   197,   201,   205,   209,
     213,   217,   221,   225,   229,   233,   237,   241,   245,   249,
     253,   257,   261,   265,   269,   273,   277,   281,   285,   289,
     293,   297,   301,   305,   309,   313,   316,   320,   323,   327,
     330,   334,   337,   341,   344,   348,   351,   355,   358,   362,
     365,   369,   372,   376,   379,   383,   386,   390,   393,   397,
     400,   404,   407,   411,   414,   418,   421,   425,   428,   432,
     435,   439,   442,   446,   449,   453,   456,   460,   463,   467,
     470,   474,   477,   481,   484,   488,   491,   495,   498,   502,
     505,   509,   512,   516,   519,   523,   526,   530,   533,   537,
     540,   544,   547,   551,   555,   559,   563,   567,   571,   575,
     579,   583,   587,   591,   595,   599,   603,   607,   611,   615,
     619,   623,   627,   631,   635,   639,   643,   647,   651,   655,
     659,   663,   667,   671,   675,   679,   683,   687,   691,   695,
     699,   703,   707,   711,   715,   719,   723,   727,   731,   735,
     739,   743,   747,   751,   755,   759,   763,   767,   771,   775,
     779,   783,   787,   791,   795,   799,   803,   807,   811,   815,
     819,   823,   827,   831,   835,   839,   843,   847,   851,   855,
     859,   863,   867,   871,   875,   879,   883,   887,   891,   895,
     899,   902,   906,   909,   913,   916,   920,   923,   927,   931,
     935,   939,   943,   947,   951,   955,   959,   963,   967,   971,
     975,   979,   983,   987,   991,   995,   999,  1003,  1007,  1011,
    1015,  1019,  1023,  1027,  1031,  1035,  1039,  1043,  1047,  1051,
    1055,  1059,  1063,  1067,  1071,  1075,  1079,  1083,  1087,  1091,
    1095,  1099,  1103,  1107,  1111,  1115,  1119,  1123,  1127,  1131,
    1135,  1139,  1143,  1147,  1151,  1155,  1159,  1163,  1167,  1171,
    1175,  1179,  1183,  1187,  1191,  1195,  1203,  1207,  1211,  1215,
    1219,  1223,  1227,  1231,  1235,  1239,  1243,  1247,  1251,  1255,
    1259,  1263,  1267,  1271,  1275,  1279,  1283,  1287,  1291,  1295,
    1299,  1303,  1307,  1311,  1315,  1319,  1323,  1327,  1331,  1335,
    1339,  1343,  1347,  1351,  1355,  1359,  1363,  1367,  1371,  1375,
    1379,  1382,  1386,  1390,  1394,  1398,  1402,  1406,  1410,  1414,
    1418,  1422,  1426,  1430,  1434,  1438,  1442,  1446,  1450,  1454,
    1458,  1462,  1468,  1474,  1480,  1486,  1492,  1498,  1502,  1506,
    1510,  1514,  1518,  1522,  1526,  1530,  1534,  1538,  1542,  1546,
    1550,  1554,  1558,  1562,  1566,  1570,  1574,  1578,  1582,  1586,
    1590,  1594,  1598,  1602,  1604,  1607,  1609,  1611,  1613,  1615,
    1617,  1623,  1629,  1637,  1645,  1651,  1660,  1669,  1672,  1675,
    1678,  1681,  1685,  1689,  1698,  1707,  1710,  1713,  1716,  1720,
    1724,  1726,  1728,  1736,  1738,  1740,  1744,  1746,  1748,  1750,
    1752,  1754,  1759,  1767,  1770,  1773,  1775,  1780,  1788,  1791,
    1793,  1795,  1796,  1802,  1805,  1808,  1809,  1818,  1824,  1826,
    1831,  1839,  1842,  1844,  1849,  1857,  1860,  1862,  1870,  1873,
    1876,  1879,  1882,  1885,  1888,  1891,  1893,  1895,  1897,  1899,
    1901,  1903,  1905,  1907,  1909,  1911,  1913,  1915,  1917,  1919,
    1921,  1923,  1925,  1927,  1929,  1931,  1933,  1935,  1937,  1939,
    1941,  1943,  1945,  1947,  1949,  1951,  1953,  1955,  1957,  1959,
    1961,  1963,  1965,  1969,  1973,  1977,  1980,  1984,  1988,  1992,
    1995,  1999,  2003,  2007,  2011,  2014,  2018,  2022,  2026,  2030,
    2034,  2038,  2042,  2046,  2050,  2054,  2058,  2061,  2065,  2069,
    2073,  2076,  2080,  2084,  2086,  2090,  2092,  2096,  2100,  2104,
    2108,  2110,  2112,  2114,  2116,  2120,  2124,  2128,  2132,  2134,
    2136,  2140,  2143,  2145,  2148,  2151,  2153,  2155,  2157,  2160,
    2163,  2165,  2168,  2172,  2178,  2180,  2185,  2191,  2195,  2200,
    2204,  2207,  2212,  2218,  2222,  2227,  2232,  2235,  2237,  2243,
    2248,  2251,  2257,  2261,  2263,  2268,  2273,  2277,  2279,  2280,
    2284,  2286,  2288,  2290,  2292,  2294,  2296,  2298,  2300,  2302,
    2304,  2306,  2310,  2312,  2315,  2321,  2326,  2328,  2330,  2332,
    2334,  2336,  2338,  2340,  2342,  2344,  2346,  2348,  2350,  2352,
    2354,  2356,  2358,  2360,  2362,  2364,  2366,  2368,  2370,  2374,
    2378,  2382,  2386,  2388,  2390,  2392,  2394,  2397,  2400,  2403,
    2407,  2411,  2415,  2419,  2423,  2427,  2431,  2435,  2439,  2443,
    2447,  2451,  2455,  2459,  2463,  2468,  2473,  2476,  2479,  2482,
    2485,  2489,  2493,  2497,  2501,  2505,  2509,  2513,  2517,  2521,
    2525,  2529,  2534,  2539,  2542,  2546,  2548,  2550,  2552,  2556,
    2561,  2566,  2571,  2578,  2585,  2592,  2599,  2606,  2611,  2614,
    2619,  2624,  2629,  2634,  2641,  2648,  2655,  2662,  2669,  2674,
    2677,  2682,  2687,  2692,  2697,  2704,  2711,  2718,  2725,  2732,
    2737,  2740,  2745,  2750,  2755,  2760,  2767,  2774,  2781,  2788,
    2795,  2800,  2803,  2808,  2813,  2818,  2823,  2830,  2837,  2844,
    2851,  2858,  2863,  2866,  2871,  2876,  2883,  2886,  2891,  2896,
    2901,  2904,  2909,  2914,  2917,  2922,  2927,  2930,  2937,  2944,
    2951,  2956,  2959,  2966,  2969,  2974,  2979,  2984,  2987,  2992,
    2997,  3002,  3005,  3010,  3015,  3018,  3023,  3028,  3031,  3036,
    3041,  3044,  3049,  3053,  3056,  3061,  3065,  3068,  3073,  3077,
    3082,  3085,  3090,  3095,  3098,  3103,  3108,  3111,  3116,  3121,
    3124,  3129,  3134,  3137,  3142,  3147,  3150,  3155,  3159,  3161,
    3165,  3167,  3171,  3173,  3178,  3182,  3184,  3189,  3194,  3199,
    3204,  3209,  3212,  3217,  3222,  3225,  3230,  3235,  3238,  3242,
    3244,  3248,  3250,  3254,  3256,  3260,  3262,  3269,  3276,  3279,
    3284,  3289,  3292,  3297,  3298,  3304,  3307,  3308,  3312,  3314,
    3316,  3320,  3323,  3325,  3329,  3332,  3334,  3336,  3340,  3343
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     344,     0,    -1,   345,    -1,   345,   346,    -1,   346,    -1,
     345,     1,    -1,   369,    -1,   393,    -1,   362,    -1,   366,
      -1,   373,    -1,    -1,   347,   380,    -1,    -1,   348,   382,
      -1,   384,    -1,    -1,   349,   388,    -1,    -1,   350,   390,
      -1,    -1,   351,   392,    -1,   334,    -1,   341,    -1,   374,
      -1,   328,    -1,   408,    -1,   352,    -1,   352,   333,   353,
      -1,   336,   353,   335,    -1,   352,    -1,    88,    -1,    89,
      -1,    90,    -1,    91,    -1,   315,    -1,    88,    -1,    89,
      -1,    90,    -1,    91,    -1,    92,    -1,    93,    -1,   315,
      -1,   325,    -1,   315,    -1,   352,    -1,   352,   342,   357,
      -1,   355,   342,   352,    -1,   355,   342,   352,   342,   357,
      -1,   352,   342,     1,    -1,   354,    -1,   354,   342,   357,
      -1,   355,   342,   354,    -1,   355,   342,   354,   342,   357,
      -1,   354,   342,     1,    -1,   359,    -1,   359,   360,    -1,
     325,    -1,   311,   325,    -1,   275,   363,    -1,   275,     1,
      -1,   364,    -1,   364,   333,   363,    -1,   365,    -1,   365,
     342,   325,    -1,   328,    -1,   326,    -1,   276,   367,    -1,
     276,     1,    -1,   368,    -1,   368,   333,   367,    -1,   365,
      -1,    94,   292,   361,    -1,    94,   292,     1,    -1,    95,
     292,   325,    -1,    95,   292,     1,    -1,    96,   292,   325,
      -1,    96,   292,     1,    -1,    97,   292,   325,    -1,    97,
     292,     1,    -1,    98,   292,   325,    -1,    98,   292,     1,
      -1,    99,   292,   326,    -1,    99,   292,     1,    -1,   100,
     292,   328,    -1,   100,   292,     1,    -1,   101,   292,   325,
      -1,   101,   292,     1,    -1,   102,   292,   328,    -1,   102,
     292,     1,    -1,   103,   292,   325,    -1,   103,   292,     1,
      -1,   104,   292,   328,    -1,   104,   292,     1,    -1,   105,
     292,   328,    -1,   105,   292,     1,    -1,   106,   292,   328,
      -1,   106,   292,     1,    -1,   107,   292,   328,    -1,   107,
     292,     1,    -1,   112,   292,   325,    -1,   112,   292,     1,
      -1,   113,   292,   325,    -1,   113,   292,     1,    -1,   114,
     292,   325,    -1,   114,     1,    -1,   115,   292,   325,    -1,
     115,     1,    -1,   116,   292,   325,    -1,   116,     1,    -1,
     117,   292,   361,    -1,   117,     1,    -1,   118,   292,   361,
      -1,   118,     1,    -1,   119,   292,   361,    -1,   119,     1,
      -1,   120,   292,   361,    -1,   120,     1,    -1,   121,   292,
     325,    -1,   121,     1,    -1,   122,   292,   325,    -1,   122,
       1,    -1,   123,   292,   325,    -1,   123,     1,    -1,   124,
     292,   325,    -1,   124,     1,    -1,   125,   292,   325,    -1,
     125,     1,    -1,   126,   292,   325,    -1,   126,     1,    -1,
     127,   292,   325,    -1,   127,     1,    -1,   128,   292,   325,
      -1,   128,     1,    -1,   129,   292,   325,    -1,   129,     1,
      -1,   130,   292,   325,    -1,   130,     1,    -1,   131,   292,
     325,    -1,   131,     1,    -1,   133,   292,   325,    -1,   133,
       1,    -1,   132,   292,   325,    -1,   132,     1,    -1,   134,
     292,   325,    -1,   134,     1,    -1,   135,   292,   325,    -1,
     135,     1,    -1,   136,   292,   325,    -1,   136,     1,    -1,
     137,   292,   325,    -1,   137,     1,    -1,   138,   292,   325,
      -1,   138,     1,    -1,   139,   292,   325,    -1,   139,     1,
      -1,   140,   292,   325,    -1,   140,     1,    -1,   141,   292,
     325,    -1,   141,     1,    -1,   142,   292,   325,    -1,   142,
       1,    -1,   143,   292,   325,    -1,   143,     1,    -1,   144,
     292,   325,    -1,   144,     1,    -1,   145,   292,   325,    -1,
     145,     1,    -1,   146,   292,   325,    -1,   146,     1,    -1,
     147,   292,   325,    -1,   147,     1,    -1,   148,   292,   361,
      -1,   148,   292,     1,    -1,   149,   292,   325,    -1,   150,
     292,   328,    -1,   174,   292,   325,    -1,   174,   292,     1,
      -1,   175,   292,   325,    -1,   175,   292,     1,    -1,   149,
     292,     1,    -1,   151,   292,   325,    -1,   151,   292,     1,
      -1,   152,   292,   325,    -1,   152,   292,     1,    -1,   153,
     292,   325,    -1,   153,   292,     1,    -1,   154,   292,   325,
      -1,   154,   292,     1,    -1,   155,   292,   325,    -1,   155,
     292,     1,    -1,   156,   292,   325,    -1,   156,   292,     1,
      -1,   157,   292,   325,    -1,   157,   292,     1,    -1,   158,
     292,   361,    -1,   158,   292,     1,    -1,   159,   292,   361,
      -1,   159,   292,     1,    -1,   160,   292,   361,    -1,   160,
     292,     1,    -1,   161,   292,   361,    -1,   161,   292,     1,
      -1,   162,   292,   361,    -1,   162,   292,     1,    -1,   163,
     292,   361,    -1,   163,   292,     1,    -1,   164,   292,   361,
      -1,   164,   292,     1,    -1,   165,   292,   325,    -1,   165,
     292,     1,    -1,   258,   292,   328,    -1,   258,   292,     1,
      -1,   176,   292,   328,    -1,   176,   292,   326,    -1,   176,
     292,     1,    -1,   177,   292,   328,    -1,   177,   292,   326,
      -1,   177,   292,     1,    -1,   178,   292,   328,    -1,   178,
     292,   326,    -1,   178,   292,     1,    -1,   179,   292,   328,
      -1,   179,   292,   326,    -1,   179,   292,     1,    -1,   180,
     292,   328,    -1,   180,   292,   326,    -1,   180,   292,     1,
      -1,   181,   292,   325,    -1,   181,   292,     1,    -1,   182,
     292,   325,    -1,   182,   292,     1,    -1,   183,   292,   325,
      -1,   183,   292,     1,    -1,   184,   292,   325,    -1,   184,
     292,     1,    -1,   185,   292,   361,    -1,   185,   292,     1,
      -1,   186,   292,   361,    -1,   186,   292,     1,    -1,   187,
     292,   361,    -1,   187,   292,     1,    -1,   188,   292,   326,
      -1,   188,   292,   328,    -1,   188,   292,     1,    -1,   189,
     292,   325,    -1,   189,   292,     1,    -1,   190,   292,   325,
      -1,   190,   292,     1,    -1,   191,   292,   325,    -1,   191,
     292,     1,    -1,   192,   292,   375,    -1,   192,   292,     1,
      -1,   193,   292,   377,    -1,   193,   292,     1,    -1,   194,
     292,   325,    -1,   194,   292,     1,    -1,   195,   292,   325,
      -1,   195,   292,     1,    -1,   196,   292,   325,    -1,   196,
       1,    -1,   197,   292,   325,    -1,   197,     1,    -1,   198,
     292,   325,    -1,   198,     1,    -1,   199,   292,   325,    -1,
     199,     1,    -1,   200,   292,   325,    -1,   200,   292,     1,
      -1,   201,   292,   325,    -1,   201,   292,     1,    -1,   202,
     292,   325,    -1,   202,   292,     1,    -1,   203,   292,   325,
      -1,   203,   292,     1,    -1,   204,   292,   325,    -1,   204,
     292,     1,    -1,   205,   292,   325,    -1,   205,   292,     1,
      -1,   206,   292,   325,    -1,   206,   292,     1,    -1,   207,
     292,   325,    -1,   207,   292,     1,    -1,   208,   292,   325,
      -1,   208,   292,     1,    -1,   209,   292,   325,    -1,   209,
     292,     1,    -1,   210,   292,   325,    -1,   210,   292,     1,
      -1,   211,   292,   325,    -1,   211,   292,     1,    -1,   212,
     292,   325,    -1,   212,   292,     1,    -1,   213,   292,   325,
      -1,   213,   292,     1,    -1,   214,   292,   325,    -1,   214,
     292,     1,    -1,   215,   292,   325,    -1,   215,   292,     1,
      -1,   216,   292,   325,    -1,   216,   292,     1,    -1,   217,
     292,   220,    -1,   217,   292,   221,    -1,   217,   292,   222,
      -1,   217,   292,   223,    -1,   217,   292,     1,    -1,   224,
     292,   325,    -1,   224,   292,     1,    -1,   225,   292,   325,
      -1,   225,   292,     1,    -1,   226,   292,   328,    -1,   226,
     292,     1,    -1,   227,   292,   328,    -1,   227,   292,     1,
      -1,   228,   292,   328,    -1,   228,   292,     1,    -1,   218,
     292,   325,    -1,   218,   292,     1,    -1,   219,   292,   325,
      -1,   219,   292,     1,    -1,   229,   292,   325,    -1,   229,
     292,     1,    -1,   230,   292,   325,    -1,   230,   292,     1,
      -1,   231,   292,   325,    -1,   231,   292,     1,    -1,   166,
     292,   325,    -1,   166,   292,     1,    -1,   167,   292,   328,
      -1,   167,   292,     1,    -1,   168,   292,   328,    -1,   168,
     292,     1,    -1,   169,   292,   325,    -1,   169,   292,     1,
      -1,   108,   292,   360,    -1,   108,   292,   360,   109,   352,
     342,   325,    -1,   108,   292,     1,    -1,   110,   292,   360,
      -1,   110,   292,     1,    -1,   111,   292,   325,    -1,   111,
     292,     1,    -1,   232,   292,   352,    -1,   232,   292,     1,
      -1,   233,   292,   325,    -1,   233,   292,     1,    -1,   234,
     292,   325,    -1,   234,   292,     1,    -1,   235,   292,   325,
      -1,   235,   292,     1,    -1,   236,   292,   325,    -1,   236,
     292,     1,    -1,   237,   292,   325,    -1,   237,   292,     1,
      -1,   238,   292,   325,    -1,   238,   292,     1,    -1,   239,
     292,   325,    -1,   239,   292,     1,    -1,   240,   292,   325,
      -1,   240,   292,     1,    -1,   241,   292,   325,    -1,   241,
     292,     1,    -1,   242,   292,   325,    -1,   242,   292,     1,
      -1,   243,   292,   325,    -1,   243,   292,     1,    -1,   244,
     292,   325,    -1,   244,   292,     1,    -1,   245,   292,   325,
      -1,   245,   292,     1,    -1,   246,   292,   325,    -1,   246,
     292,     1,    -1,   247,   292,   325,    -1,   247,   292,     1,
      -1,   248,   292,   326,    -1,   248,   292,   328,    -1,   248,
     292,     1,    -1,   249,   292,   325,    -1,   249,   292,   326,
      -1,   249,   292,     1,    -1,   250,   292,   325,    -1,   250,
       1,    -1,   251,   292,   325,    -1,   251,   292,     1,    -1,
     252,   292,   325,    -1,   252,   292,     1,    -1,   253,   292,
     325,    -1,   253,   292,     1,    -1,   254,   292,   325,    -1,
     254,   292,     1,    -1,   255,   292,   325,    -1,   255,   292,
       1,    -1,   256,   292,   325,    -1,   256,   292,     1,    -1,
     257,   292,   325,    -1,   257,   292,     1,    -1,   259,   292,
     325,    -1,   259,   292,     1,    -1,   260,   292,   325,    -1,
     260,   292,     1,    -1,   262,   292,   325,    -1,   262,   292,
       1,    -1,   263,   322,   264,   292,   328,    -1,   263,   322,
     264,   292,     1,    -1,   263,   322,   265,   292,   328,    -1,
     263,   322,   265,   292,     1,    -1,   263,   322,   266,   292,
     328,    -1,   263,   322,   266,   292,     1,    -1,   267,   292,
     325,    -1,   268,   292,   325,    -1,   270,   292,   361,    -1,
     270,   292,     1,    -1,   269,   292,   361,    -1,   269,   292,
       1,    -1,   271,   292,   325,    -1,   271,   292,     1,    -1,
     272,   292,   325,    -1,   272,   292,     1,    -1,   273,   292,
     325,    -1,   273,   292,     1,    -1,   274,   292,   325,    -1,
     274,   292,     1,    -1,    41,   292,   325,    -1,    41,   292,
       1,    -1,    38,   292,   325,    -1,    38,   292,     1,    -1,
      42,   292,   355,    -1,    42,   292,     1,    -1,    43,   292,
     361,    -1,    43,   292,     1,    -1,    44,   292,   325,    -1,
      44,   292,     1,    -1,    45,   292,   325,    -1,    45,   292,
       1,    -1,   372,    -1,     1,   292,    -1,   326,    -1,    57,
      -1,   326,    -1,    57,    -1,   325,    -1,   370,   322,   371,
     292,   325,    -1,   370,   322,   371,   292,   328,    -1,   370,
     322,   371,   292,   325,   261,   328,    -1,   370,   322,   371,
     292,   328,   261,   328,    -1,   370,   322,   371,   292,     1,
      -1,   370,   339,   325,   340,   322,   371,   292,   325,    -1,
     370,   339,   325,   340,   322,   371,   292,   328,    -1,   170,
     328,    -1,   170,     1,    -1,   171,   328,    -1,   171,     1,
      -1,   171,   292,   328,    -1,   171,   292,     1,    -1,   172,
     336,   328,   333,   328,   333,   328,   335,    -1,   172,   336,
     328,   333,   328,   333,   361,   335,    -1,   172,     1,    -1,
     173,   328,    -1,   173,     1,    -1,   173,   292,   328,    -1,
     173,   292,     1,    -1,   375,    -1,   377,    -1,   325,   322,
     325,   322,   325,   322,   325,    -1,   329,    -1,   376,    -1,
     339,   376,   340,    -1,   325,    -1,   326,    -1,   328,    -1,
      14,    -1,    15,    -1,   379,   337,   411,   338,    -1,    14,
     339,   378,   340,   337,   411,   338,    -1,    14,     1,    -1,
      15,     1,    -1,    16,    -1,   381,   337,   411,   338,    -1,
      16,   339,   378,   340,   337,   411,   338,    -1,    16,     1,
      -1,    17,    -1,    18,    -1,    -1,   383,   337,   385,   411,
     338,    -1,    17,     1,    -1,    18,     1,    -1,    -1,    17,
     339,   378,   340,   386,   337,   411,   338,    -1,    17,   339,
     378,   340,     1,    -1,    19,    -1,   387,   337,   411,   338,
      -1,    19,   339,   378,   340,   337,   411,   338,    -1,    19,
       1,    -1,    20,    -1,   389,   337,   411,   338,    -1,    20,
     339,   378,   340,   337,   411,   338,    -1,    20,     1,    -1,
      21,    -1,   391,   339,   332,   340,   337,   411,   338,    -1,
      21,     1,    -1,   289,   328,    -1,   289,     1,    -1,   290,
     328,    -1,   290,     1,    -1,   291,   328,    -1,   291,     1,
      -1,   306,    -1,   305,    -1,   301,    -1,   300,    -1,   310,
      -1,   309,    -1,   308,    -1,   307,    -1,   394,    -1,   304,
      -1,   306,    -1,   305,    -1,   303,    -1,   302,    -1,   301,
      -1,   300,    -1,   304,    -1,   310,    -1,   309,    -1,   308,
      -1,   307,    -1,    71,    -1,    72,    -1,    73,    -1,    81,
      -1,    79,    -1,    83,    -1,    75,    -1,    77,    -1,    85,
      -1,    87,    -1,   400,    -1,    80,    -1,    78,    -1,    74,
      -1,    76,    -1,   402,    -1,    70,   396,   439,    -1,    70,
     396,   326,    -1,    70,   396,     1,    -1,    70,     1,    -1,
     399,   396,   439,    -1,   399,   396,    86,    -1,   399,   396,
       1,    -1,   399,     1,    -1,   401,   395,   439,    -1,   401,
     394,   439,    -1,   401,   395,     1,    -1,   401,   394,     1,
      -1,   401,     1,    -1,    84,   394,   356,    -1,    84,   394,
     439,    -1,    84,   394,     1,    -1,    82,   394,   356,    -1,
      82,   394,   439,    -1,    82,   394,     1,    -1,   403,   396,
     405,    -1,   403,   396,   439,    -1,   403,   396,   406,    -1,
     403,   396,    86,    -1,   403,   396,     1,    -1,   403,     1,
      -1,    86,   394,   399,    -1,    86,   394,   403,    -1,    86,
     394,     1,    -1,    86,     1,    -1,   374,   314,   374,    -1,
     374,   314,   325,    -1,   374,    -1,   374,   314,     1,    -1,
     326,    -1,   406,   322,   326,    -1,   406,   311,   326,    -1,
     406,   322,     1,    -1,   406,   311,     1,    -1,   326,    -1,
     327,    -1,   325,    -1,   407,    -1,   408,   322,   407,    -1,
     408,   311,   407,    -1,   408,   322,     1,    -1,   408,   311,
       1,    -1,   442,    -1,   412,    -1,   337,   411,   338,    -1,
     411,   412,    -1,   412,    -1,   411,     1,    -1,   409,   334,
      -1,   413,    -1,   417,    -1,   418,    -1,   446,   334,    -1,
     440,   334,    -1,   334,    -1,   409,     1,    -1,    46,   439,
     410,    -1,    46,   439,   410,    47,   410,    -1,   439,    -1,
      56,   414,   342,   411,    -1,    56,   314,   414,   342,   411,
      -1,    56,   414,   342,    -1,    56,   314,   414,   342,    -1,
      57,   342,   411,    -1,    57,   342,    -1,    56,     1,   342,
     411,    -1,    56,   314,     1,   342,   411,    -1,    56,     1,
     342,    -1,    56,   314,     1,   342,    -1,    56,   414,   342,
       1,    -1,   416,   415,    -1,   415,    -1,    55,   439,   337,
     416,   338,    -1,    55,   439,   337,   338,    -1,    55,     1,
      -1,    55,   439,   337,     1,   338,    -1,    58,   439,   410,
      -1,   326,    -1,   326,   339,   361,   340,    -1,   326,   339,
     328,   340,    -1,   420,   322,   419,    -1,   419,    -1,    -1,
     278,   422,   420,    -1,   279,    -1,   280,    -1,   281,    -1,
     282,    -1,   283,    -1,   284,    -1,   285,    -1,   286,    -1,
     287,    -1,   326,    -1,   424,    -1,   423,   322,   424,    -1,
     277,    -1,   426,   425,    -1,   426,   425,   339,   361,   340,
      -1,   426,   425,   339,   340,    -1,   427,    -1,   429,    -1,
     427,    -1,   429,    -1,   428,    -1,   427,    -1,   434,    -1,
     328,    -1,   330,    -1,   331,    -1,   292,    -1,   430,    -1,
     433,    -1,   434,    -1,   361,    -1,   328,    -1,   431,    -1,
     433,    -1,   434,    -1,   421,    -1,   409,    -1,   404,    -1,
     337,   411,   338,    -1,   337,     1,   338,    -1,   336,   440,
     335,    -1,   336,     1,   335,    -1,   318,    -1,   316,    -1,
     311,    -1,   437,    -1,   438,   439,    -1,   321,   439,    -1,
     320,   439,    -1,   439,   312,   439,    -1,   439,   311,   439,
      -1,   439,   315,   439,    -1,   439,   314,   439,    -1,   439,
     313,   439,    -1,   439,   295,   439,    -1,   439,   296,   439,
      -1,   439,   297,   439,    -1,   439,   298,   439,    -1,   439,
     299,   439,    -1,   439,   398,   439,    -1,   439,   397,   439,
      -1,   439,   294,   439,    -1,   439,   293,   439,    -1,   336,
     439,   335,    -1,   323,   336,   439,   335,    -1,   324,   336,
     439,   335,    -1,   319,   439,    -1,   438,     1,    -1,   321,
       1,    -1,   320,     1,    -1,   439,   312,     1,    -1,   439,
     311,     1,    -1,   439,   315,     1,    -1,   439,   314,     1,
      -1,   439,   313,     1,    -1,   439,   295,     1,    -1,   439,
     296,     1,    -1,   439,   398,     1,    -1,   439,   397,     1,
      -1,   439,   294,     1,    -1,   439,   293,     1,    -1,   323,
     336,     1,   335,    -1,   324,   336,     1,   335,    -1,   319,
       1,    -1,   436,   435,   439,    -1,    67,    -1,    68,    -1,
      69,    -1,     3,   336,   335,    -1,     3,   336,   406,   335,
      -1,     3,   336,   328,   335,    -1,     3,   336,   374,   335,
      -1,     3,   336,   406,   333,   325,   335,    -1,     3,   336,
     328,   333,   325,   335,    -1,     3,   336,   374,   333,   325,
     335,    -1,     3,   336,    61,   333,    62,   335,    -1,     3,
     336,    61,   333,   325,   335,    -1,     3,   336,    61,   335,
      -1,     3,     1,    -1,     3,   336,     1,   335,    -1,     7,
     336,   406,   335,    -1,     7,   336,   328,   335,    -1,     7,
     336,   374,   335,    -1,     7,   336,   406,   333,   325,   335,
      -1,     7,   336,   328,   333,   325,   335,    -1,     7,   336,
     374,   333,   325,   335,    -1,     7,   336,    61,   333,    62,
     335,    -1,     7,   336,    61,   333,   325,   335,    -1,     7,
     336,    61,   335,    -1,     7,     1,    -1,     7,   336,     1,
     335,    -1,     4,   336,   406,   335,    -1,     4,   336,   328,
     335,    -1,     4,   336,   374,   335,    -1,     4,   336,   406,
     333,   325,   335,    -1,     4,   336,   328,   333,   325,   335,
      -1,     4,   336,   374,   333,   325,   335,    -1,     4,   336,
      61,   333,    62,   335,    -1,     4,   336,    61,   333,   325,
     335,    -1,     4,   336,    61,   335,    -1,     4,     1,    -1,
       4,   336,     1,   335,    -1,     5,   336,   406,   335,    -1,
       5,   336,   328,   335,    -1,     5,   336,   374,   335,    -1,
       5,   336,   406,   333,   325,   335,    -1,     5,   336,   328,
     333,   325,   335,    -1,     5,   336,   374,   333,   325,   335,
      -1,     5,   336,    61,   333,    62,   335,    -1,     5,   336,
      61,   333,   325,   335,    -1,     5,   336,    61,   335,    -1,
       5,     1,    -1,     5,   336,     1,   335,    -1,     6,   336,
     406,   335,    -1,     6,   336,   328,   335,    -1,     6,   336,
     374,   335,    -1,     6,   336,   406,   333,   325,   335,    -1,
       6,   336,   328,   333,   325,   335,    -1,     6,   336,   374,
     333,   325,   335,    -1,     6,   336,    61,   333,    62,   335,
      -1,     6,   336,    61,   333,   325,   335,    -1,     6,   336,
      61,   335,    -1,     6,     1,    -1,     6,   336,     1,   335,
      -1,    12,   336,   328,   335,    -1,    12,   336,   325,   333,
     328,   335,    -1,    12,     1,    -1,    12,   336,     1,   335,
      -1,    64,   336,   325,   335,    -1,    64,   336,   365,   335,
      -1,    64,     1,    -1,    65,   336,   325,   335,    -1,    65,
     336,   365,   335,    -1,    65,     1,    -1,    66,   336,   325,
     335,    -1,    66,   336,   365,   335,    -1,    66,     1,    -1,
     441,   336,   432,   333,   365,   335,    -1,   441,   336,   432,
     333,     1,   335,    -1,   441,   336,     1,   333,   365,   335,
      -1,   441,   336,     1,   335,    -1,   441,     1,    -1,    13,
     336,   328,   333,   328,   335,    -1,    13,     1,    -1,    13,
     336,     1,   335,    -1,    14,   336,   439,   335,    -1,    14,
     336,   326,   335,    -1,    14,     1,    -1,    14,   336,     1,
     335,    -1,    22,   336,   328,   335,    -1,    23,   336,   328,
     335,    -1,    23,     1,    -1,    23,   336,     1,   335,    -1,
      26,   336,   328,   335,    -1,    26,     1,    -1,    26,   336,
       1,   335,    -1,    28,   336,   325,   335,    -1,    28,     1,
      -1,    28,   336,     1,   335,    -1,    27,   336,   325,   335,
      -1,    27,     1,    -1,    27,   336,     1,   335,    -1,    29,
     336,   335,    -1,    29,     1,    -1,    31,   336,   361,   335,
      -1,    31,   336,   335,    -1,    31,     1,    -1,    31,   336,
       1,   335,    -1,    32,   336,   335,    -1,    24,   336,   328,
     335,    -1,    24,     1,    -1,    24,   336,     1,   335,    -1,
      25,   336,   328,   335,    -1,    25,     1,    -1,    25,   336,
       1,   335,    -1,    35,   336,   328,   335,    -1,    35,     1,
      -1,    35,   336,     1,   335,    -1,    33,   336,   328,   335,
      -1,    33,     1,    -1,    33,   336,     1,   335,    -1,    34,
     336,   328,   335,    -1,    34,     1,    -1,    34,   336,     1,
     335,    -1,    36,   336,   328,   335,    -1,    36,     1,    -1,
      36,   336,     1,   335,    -1,    37,   336,   335,    -1,    37,
      -1,    38,   336,   335,    -1,    38,    -1,    39,   336,   335,
      -1,    39,    -1,    40,   336,   325,   335,    -1,    40,   336,
     335,    -1,    40,    -1,    40,   336,     1,   335,    -1,    42,
     336,   355,   335,    -1,    42,   336,     1,   335,    -1,    48,
     336,   352,   335,    -1,    48,   336,     1,   335,    -1,    48,
       1,    -1,    49,   336,   325,   335,    -1,    49,   336,     1,
     335,    -1,    49,     1,    -1,    50,   336,   358,   335,    -1,
      50,   336,     1,   335,    -1,    50,     1,    -1,    51,   336,
     335,    -1,    51,    -1,    52,   336,   335,    -1,    52,    -1,
      53,   336,   335,    -1,    53,    -1,    54,   336,   335,    -1,
      54,    -1,    59,   336,   328,   333,   325,   335,    -1,    59,
     336,   328,   333,   439,   335,    -1,    59,     1,    -1,    59,
     336,     1,   335,    -1,    60,   336,   328,   335,    -1,    60,
       1,    -1,    60,   336,     1,   335,    -1,    -1,   326,   443,
     336,   444,   335,    -1,   326,     1,    -1,    -1,   444,   333,
     445,    -1,   445,    -1,   439,    -1,     9,   336,   335,    -1,
       9,   439,    -1,     9,    -1,     8,   336,   335,    -1,     8,
     439,    -1,     8,    -1,    10,    -1,    10,   336,   335,    -1,
      10,   439,    -1,    11,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   619,   619,   622,   623,   624,   627,   628,   629,   630,
     631,   632,   632,   633,   633,   634,   635,   635,   636,   636,
     637,   637,   638,   639,   642,   658,   666,   680,   681,   687,
     688,   692,   693,   694,   695,   696,   699,   700,   701,   702,
     703,   704,   705,   708,   709,   712,   713,   714,   715,   716,
     720,   721,   722,   723,   724,   728,   729,   732,   733,   736,
     737,   739,   740,   743,   746,   752,   753,   757,   758,   761,
     762,   765,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   782,   783,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   805,   806,   809,
     810,   811,   812,   813,   814,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   870,   871,   874,
     875,   878,   879,   880,   881,   884,   885,   888,   889,   892,
     893,   896,   897,   898,   899,   900,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   943,   944,   951,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   980,   981,   988,   989,   996,   997,  1004,  1005,  1012,
    1013,  1023,  1024,  1038,  1052,  1053,  1060,  1061,  1068,  1069,
    1076,  1077,  1086,  1087,  1096,  1097,  1104,  1105,  1112,  1113,
    1120,  1121,  1128,  1129,  1136,  1137,  1144,  1145,  1152,  1153,
    1160,  1161,  1168,  1169,  1176,  1177,  1184,  1185,  1192,  1193,
    1200,  1201,  1208,  1209,  1216,  1217,  1224,  1225,  1232,  1234,
    1241,  1242,  1253,  1254,  1261,  1262,  1269,  1270,  1277,  1278,
    1285,  1286,  1293,  1300,  1307,  1314,  1321,  1328,  1329,  1336,
    1337,  1344,  1345,  1352,  1353,  1360,  1361,  1368,  1369,  1376,
    1377,  1384,  1385,  1392,  1393,  1400,  1401,  1402,  1403,  1406,
    1407,  1410,  1411,  1412,  1413,  1425,  1438,  1440,  1451,  1452,
    1453,  1454,  1460,  1461,  1471,  1472,  1473,  1474,  1475,  1476,
    1483,  1484,  1491,  1492,  1493,  1494,  1495,  1496,  1497,  1498,
    1499,  1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,
    1515,  1516,  1523,  1524,  1531,  1538,  1539,  1540,  1567,  1568,
    1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,
    1589,  1590,  1599,  1600,  1609,  1610,  1619,  1620,  1621,  1622,
    1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,
    1633,  1634,  1635,  1636,  1638,  1639,  1641,  1643,  1644,  1645,
    1648,  1649,  1652,  1653,  1654,  1657,  1658,  1661,  1662,  1663,
    1671,  1676,  1681,  1686,  1691,  1694,  1699,  1707,  1713,  1714,
    1724,  1725,  1735,  1736,  1747,  1758,  1759,  1765,  1766,  1772,
    1776,  1777,  1780,  1809,  1824,  1825,  1829,  1840,  1841,  1845,
    1846,  1850,  1859,  1877,  1878,  1881,  1884,  1893,  1911,  1915,
    1916,  1921,  1921,  1930,  1931,  1933,  1932,  1957,  1962,  1965,
    1974,  1992,  1995,  1998,  2007,  2025,  2028,  2031,  2050,  2053,
    2054,  2055,  2056,  2057,  2058,  2080,  2081,  2082,  2083,  2086,
    2087,  2088,  2089,  2092,  2093,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2108,  2109,  2110,  2111,  2118,  2119,  2120,  2127,
    2128,  2129,  2133,  2134,  2135,  2136,  2137,  2142,  2143,  2146,
    2147,  2148,  2154,  2156,  2158,  2159,  2161,  2163,  2165,  2167,
    2169,  2170,  2172,  2173,  2174,  2175,  2177,  2179,  2181,  2183,
    2185,  2187,  2188,  2224,  2226,  2228,  2230,  2233,  2235,  2237,
    2239,  2243,  2244,  2255,  2256,  2260,  2261,  2277,  2293,  2294,
    2297,  2298,  2299,  2308,  2309,  2325,  2341,  2343,  2350,  2392,
    2393,  2396,  2397,  2398,  2401,  2402,  2403,  2404,  2405,  2406,
    2407,  2408,  2411,  2419,  2429,  2446,  2453,  2460,  2467,  2474,
    2479,  2484,  2485,  2486,  2487,  2488,  2491,  2500,  2507,  2532,
    2548,  2549,  2554,  2573,  2582,  2594,  2609,  2610,  2613,  2613,
    2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2634,
    2637,  2638,  2641,  2648,  2651,  2658,  2664,  2665,  2674,  2675,
    2676,  2679,  2680,  2692,  2716,  2727,  2758,  2762,  2772,  2786,
    2798,  2799,  2801,  2802,  2803,  2817,  2818,  2819,  2820,  2821,
    2822,  2823,  2827,  2828,  2829,  2842,  2848,  2849,  2850,  2851,
    2852,  2853,  2854,  2855,  2856,  2857,  2858,  2859,  2860,  2861,
    2862,  2880,  2881,  2882,  2883,  2884,  2885,  2886,  2887,  2888,
    2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,  2898,  2900,
    2901,  2902,  2903,  2904,  2907,  2925,  2926,  2927,  2930,  2931,
    2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,  2961,
    2962,  2963,  2964,  2972,  2980,  2988,  2996,  3004,  3012,  3020,
    3028,  3036,  3037,  3039,  3047,  3055,  3063,  3072,  3081,  3090,
    3098,  3107,  3115,  3116,  3118,  3121,  3122,  3123,  3124,  3131,
    3138,  3139,  3145,  3152,  3153,  3159,  3166,  3167,  3173,  3176,
    3179,  3180,  3181,  3184,  3185,  3186,  3195,  3204,  3205,  3206,
    3207,  3208,  3209,  3210,  3211,  3212,  3213,  3214,  3215,  3216,
    3217,  3218,  3219,  3220,  3221,  3225,  3229,  3230,  3231,  3232,
    3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,
    3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,
    3253,  3254,  3255,  3256,  3264,  3272,  3280,  3281,  3283,  3285,
    3296,  3297,  3298,  3314,  3315,  3316,  3320,  3323,  3324,  3327,
    3330,  3333,  3336,  3339,  3342,  3345,  3348,  3351,  3354,  3355,
    3356,  3359,  3360,  3361,  3361,  3394,  3396,  3398,  3399,  3402,
    3419,  3423,  3427,  3431,  3436,  3440,  3445,  3449,  3453,  3457
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR",
  "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE", "LOGENGINEDATA",
  "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE", "ALIAS",
  "SR_AUTO_ALIASES", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF", "DNS_TLS_PREF",
  "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO",
  "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH", "DNS_NAPTR_IGNORE_RFC",
  "DNS_CACHE_INIT", "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "DNS_CACHE_REC_PREF", "AUTO_BIND_IPV6", "DST_BLST_INIT", "USE_DST_BLST",
  "DST_BLST_MEM", "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "IP_FREE_BIND", "PORT", "STAT", "CHILDREN", "SOCKET_WORKERS",
  "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK", "CHECK_VIA",
  "PHONE2TEL", "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY", "MEMJOIN",
  "MEMSTATUSMODE", "CORELOG", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "REPLY_TO_VIA", "LOADMODULE",
  "LOADPATH", "MODPARAM", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE",
  "USER", "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP",
  "TCP_ACCEPT_ALIASES", "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT",
  "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME", "TCP_POLL_METHOD",
  "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT",
  "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE",
  "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX",
  "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT",
  "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2",
  "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL",
  "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL",
  "TCP_OPT_ACCEPT_HEP3", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "DISABLE_TLS", "ENABLE_TLS", "TLSLOG", "TLS_PORT_NO", "TLS_METHOD",
  "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3",
  "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE",
  "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP",
  "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE",
  "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES",
  "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "CFG_DESCRIPTION", "SERVER_ID",
  "KEMI", "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK",
  "EVENT_ROUTE_CALLBACK", "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM",
  "LATENCY_CFG_LOG", "LATENCY_LOG", "LATENCY_LIMIT_DB",
  "LATENCY_LIMIT_ACTION", "MSG_TIME", "ONSEND_RT_REPLY", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "STRDIFF", "STREQ",
  "INTDIFF", "INTEQ", "MATCH", "DIFF", "EQUAL_T", "LTE", "GTE", "LT", "GT",
  "MINUS", "PLUS", "MODULO", "SLASH", "STAR", "BIN_NOT", "UNARY", "NOT",
  "DEFINED", "STRCAST", "INTCAST", "DOT", "STRLEN", "STREMPTY", "NUMBER",
  "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR", "AVP_OR_PVAR",
  "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var_idn", "cfg_var",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "route_name",
  "route_main", "route_stm", "failure_route_main", "failure_route_stm",
  "route_reply_main", "onreply_route_stm", "$@6", "$@7",
  "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   343,   344,   345,   345,   345,   346,   346,   346,   346,
     346,   347,   346,   348,   346,   346,   349,   346,   350,   346,
     351,   346,   346,   346,   352,   352,   352,   353,   353,   354,
     354,   355,   355,   355,   355,   355,   356,   356,   356,   356,
     356,   356,   356,   357,   357,   358,   358,   358,   358,   358,
     359,   359,   359,   359,   359,   360,   360,   361,   361,   362,
     362,   363,   363,   364,   364,   365,   365,   366,   366,   367,
     367,   368,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   370,   370,   371,   371,   371,
     372,   372,   372,   372,   372,   372,   372,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     374,   374,   375,   376,   377,   377,   378,   378,   378,   379,
     379,   380,   380,   380,   380,   381,   382,   382,   382,   383,
     383,   385,   384,   384,   384,   386,   384,   384,   387,   388,
     388,   388,   389,   390,   390,   390,   391,   392,   392,   393,
     393,   393,   393,   393,   393,   394,   394,   394,   394,   395,
     395,   395,   395,   396,   396,   397,   397,   397,   397,   397,
     397,   397,   398,   398,   398,   398,   399,   399,   399,   400,
     400,   400,   401,   401,   401,   401,   401,   402,   402,   403,
     403,   403,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   405,   405,   405,   405,   406,   406,   406,   406,   406,
     407,   407,   407,   408,   408,   408,   408,   408,   409,   410,
     410,   411,   411,   411,   412,   412,   412,   412,   412,   412,
     412,   412,   413,   413,   414,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   416,   416,   417,   417,
     417,   417,   418,   419,   419,   419,   420,   420,   422,   421,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   424,
     425,   425,   426,   427,   428,   429,   430,   430,   431,   431,
     431,   432,   432,   432,   433,   434,   435,   436,   436,   436,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   438,   438,   438,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   440,   441,   441,   441,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   443,   442,   442,   444,   444,   444,   445,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     7,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     5,     5,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     2,     1,     1,     1,     1,     1,
       5,     5,     7,     7,     5,     8,     8,     2,     2,     2,
       2,     3,     3,     8,     8,     2,     2,     2,     3,     3,
       1,     1,     7,     1,     1,     3,     1,     1,     1,     1,
       1,     4,     7,     2,     2,     1,     4,     7,     2,     1,
       1,     0,     5,     2,     2,     0,     8,     5,     1,     4,
       7,     2,     1,     4,     7,     2,     1,     7,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     2,     3,     3,     3,     2,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       2,     3,     3,     1,     3,     1,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     1,
       3,     2,     1,     2,     2,     1,     1,     1,     2,     2,
       1,     2,     3,     5,     1,     4,     5,     3,     4,     3,
       2,     4,     5,     3,     4,     4,     2,     1,     5,     4,
       2,     5,     3,     1,     4,     4,     3,     1,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     1,     1,     1,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     4,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     4,     2,     3,     1,     1,     1,     3,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     6,     6,     4,     2,
       4,     4,     4,     4,     6,     6,     6,     6,     6,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     6,     2,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     6,     6,     6,
       4,     2,     6,     2,     4,     4,     4,     2,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     3,     2,     4,     3,     2,     4,     3,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     3,     1,     3,
       1,     3,     1,     4,     3,     1,     4,     4,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     3,     1,
       3,     1,     3,     1,     3,     1,     6,     6,     2,     4,
       4,     2,     4,     0,     5,     2,     0,     3,     1,     1,
       3,     2,     1,     3,     2,     1,     1,     3,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     436,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   435,    22,
      23,     0,     0,     4,     0,     0,     0,     0,     0,     8,
       9,     6,     0,   433,    10,     0,    15,     7,   434,   483,
       0,   484,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   105,     0,   107,
       0,   109,     0,   111,     0,   113,     0,   115,     0,   117,
       0,   119,     0,   121,     0,   123,     0,   125,     0,   127,
       0,   129,     0,   131,     0,   133,     0,   135,     0,   137,
       0,   139,     0,   143,     0,   141,     0,   145,     0,   147,
       0,   149,     0,   151,     0,   153,     0,   155,     0,   157,
       0,   159,     0,   161,     0,   163,     0,   165,     0,   167,
       0,   169,     0,   171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   448,   447,   450,
       0,   449,   455,     0,   457,     0,   456,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   260,
       0,   262,     0,   264,     0,   266,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   380,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    60,    66,    65,    59,    61,
      63,    68,    71,    67,    69,   500,   499,   502,   501,   504,
     503,     1,     5,     3,     0,     0,     0,    12,     0,     0,
      14,     0,     0,    17,     0,     0,    19,     0,     0,    21,
       0,     0,   481,   466,   467,   468,     0,   424,   423,   422,
     421,   426,    31,    32,    33,    34,    35,   425,   428,     0,
      57,   427,   430,   429,   432,   431,    73,    72,    75,    74,
      77,    76,    79,    78,    81,    80,    83,    82,    85,    84,
      87,    86,    89,    88,    91,    90,    93,    92,    95,    94,
      97,    96,    99,    98,   336,   582,   580,   581,    25,   463,
       0,     0,    30,    50,     0,    55,   334,    24,   460,   464,
     461,   583,    26,   338,   337,   340,   339,   101,   100,   103,
     102,   104,   106,   108,   110,   112,   114,   116,   118,   120,
     122,   124,   126,   128,   130,   132,   134,   136,   138,   142,
     140,   144,   146,   148,   150,   152,   154,   156,   158,   160,
     162,   164,   166,   168,   170,   173,   172,   180,   174,   175,
     182,   181,   184,   183,   186,   185,   188,   187,   190,   189,
     192,   191,   194,   193,   196,   195,   198,   197,   200,   199,
     202,   201,   204,   203,   206,   205,   208,   207,   210,   209,
     327,   326,   329,   328,   331,   330,   333,   332,   452,   451,
       0,   459,   458,   177,   176,   179,   178,   215,   214,   213,
     218,   217,   216,   221,   220,   219,   224,   223,   222,   227,
     226,   225,   229,   228,   231,   230,   233,   232,   235,   234,
     237,   236,   239,   238,   241,   240,   244,   242,   243,   246,
     245,   248,   247,   250,   249,   252,     0,   251,   254,   253,
     256,   255,   258,   257,   259,   261,   263,   265,   268,   267,
     270,   269,   272,   271,   274,   273,   276,   275,   278,   277,
     280,   279,   282,   281,   284,   283,   286,   285,   288,   287,
     290,   289,   292,   291,   294,   293,   296,   295,   298,   297,
     300,   299,   305,   301,   302,   303,   304,   317,   316,   319,
     318,   307,   306,   309,   308,   311,   310,   313,   312,   315,
     314,   321,   320,   323,   322,   325,   324,   342,   341,   344,
     343,   346,   345,   348,   347,   350,   349,   352,   351,   354,
     353,   356,   355,   358,   357,   360,   359,   362,   361,   364,
     363,   366,   365,   368,   367,   370,   369,   372,   371,   375,
     373,   374,   378,   376,   377,   379,   382,   381,   384,   383,
     386,   385,   388,   387,   390,   389,   392,   391,   394,   393,
     212,   211,   396,   395,   398,   397,   400,   399,     0,     0,
       0,   407,   408,   412,   411,   410,   409,   414,   413,   416,
     415,   418,   417,   420,   419,     0,     0,     0,   473,     0,
     474,     0,   478,     0,     0,   491,     0,     0,   495,     0,
       0,   498,     0,   438,   439,   437,     0,     0,     0,     0,
      58,     0,    27,     0,     0,     0,     0,    56,     0,     0,
       0,     0,     0,     0,     0,    62,    64,    70,     0,     0,
       0,     0,     0,     0,   885,   882,   886,   889,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   838,   840,   842,   845,     0,
       0,     0,     0,     0,   859,   861,   863,   865,     0,     0,
       0,     0,     0,     0,     0,   715,   716,   717,   642,     0,
     654,   655,   600,     0,     0,   592,   595,   596,   597,     0,
     646,   647,   657,   658,   659,     0,     0,     0,   588,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     487,     0,     0,     0,    29,   465,    54,    44,    43,    51,
      52,     0,   587,   582,   585,   586,   584,     0,   402,   401,
     404,   403,   406,   405,     0,   728,     0,   750,     0,   761,
       0,   772,     0,   739,     0,     0,   526,   527,   528,   539,
     532,   540,   533,   538,   530,   537,   529,     0,   531,     0,
     534,     0,   535,   628,   674,   673,   672,     0,     0,     0,
       0,     0,   661,     0,     0,   660,     0,   536,     0,   541,
       0,   667,   666,   665,     0,   648,   650,   649,   662,   663,
     664,   675,     0,   884,     0,   881,     0,   888,   776,     0,
     793,     0,   797,     0,     0,   801,     0,   820,     0,   823,
       0,   804,     0,   810,     0,   807,     0,   813,     0,   816,
       0,     0,   829,     0,   832,     0,   826,     0,   835,     0,
       0,     0,     0,     0,     0,     0,     0,   851,     0,   854,
       0,   857,     0,     0,     0,     0,     0,   620,     0,     0,
     868,     0,   871,     0,   780,     0,   783,     0,   786,     0,
     875,     0,   601,   594,   593,   471,   591,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,     0,   640,   643,
     656,     0,   599,   791,     0,   598,     0,   476,     0,   489,
       0,   493,     0,   444,   440,   441,     0,   482,     0,     0,
      28,     0,     0,     0,     0,     0,     0,   575,     0,   718,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   545,   508,   507,   514,   506,   505,   513,     0,
       0,     0,   570,     0,     0,   713,   696,   699,   678,   698,
     677,     0,     0,     0,   883,   648,   649,   663,   664,     0,
       0,     0,     0,   549,     0,   554,   512,   511,   510,   509,
       0,     0,   566,     0,   643,   697,   676,     0,     0,     0,
       0,     0,     0,     0,   520,   519,   518,   517,   521,   516,
     515,   525,   524,   523,   522,     0,     0,     0,     0,     0,
       0,     0,   880,   887,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   812,     0,   815,     0,   818,
       0,     0,     0,     0,     0,     0,     0,     0,   837,   839,
     841,     0,     0,   844,     0,     0,     0,   602,   589,     0,
       0,     0,     0,     0,    45,     0,     0,   858,   860,   862,
     864,     0,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   876,     0,     0,   714,     0,   653,     0,
     651,     0,   652,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,   335,     0,     0,     0,   729,     0,   727,
       0,   720,     0,   721,     0,     0,     0,   719,   751,     0,
     749,     0,   742,     0,   743,     0,   741,   762,     0,   760,
       0,   753,     0,   754,     0,   752,   773,     0,   771,     0,
     764,     0,   765,     0,   763,   740,     0,   738,     0,   731,
       0,   732,     0,   730,   544,     0,   542,   560,    36,    37,
      38,    39,    40,    41,    42,   558,   559,   557,   555,   556,
     569,   567,   568,   623,   627,   629,     0,     0,     0,     0,
     671,   693,   670,   669,   668,   548,     0,   546,   553,   551,
     552,   550,   565,     0,    57,     0,   573,   561,   563,   562,
       0,   710,   692,   709,   691,   705,   684,   706,   685,   686,
     687,   688,   701,   680,   700,   679,   704,   683,   703,   682,
     702,   681,   708,   690,   707,   689,   777,     0,   774,   794,
       0,   798,   796,   795,   799,   802,   800,   821,   819,   824,
     822,   805,   803,   811,   809,   808,   806,   817,   814,   830,
     828,   833,   831,   827,   825,   836,   834,   846,   843,   848,
     847,     0,     0,   850,   849,   853,   852,   856,     0,     0,
     855,     0,     0,     0,   619,   617,     0,   869,     0,   872,
     870,   778,   779,   781,   782,   784,   785,   879,     0,   878,
     641,   645,     0,   790,   643,     0,     0,     0,     0,     0,
     442,   443,     0,   486,     0,   453,   454,   472,     0,     0,
       0,     0,   579,   577,   578,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   711,
     694,   712,   695,     0,     0,     0,     0,   590,   603,    49,
      46,    47,   621,     0,     0,     0,   604,   610,   618,   616,
      57,     0,     0,   874,     0,     0,     0,   477,   490,   494,
     497,   445,   446,   462,   725,   726,   723,   724,   722,   747,
     748,   745,   746,   744,   758,   759,   756,   757,   755,   769,
     770,   767,   768,   766,   736,   737,   734,   735,   733,     0,
       0,   626,   574,   572,   571,   644,   775,   792,     0,   613,
       0,     0,     0,     0,   866,   867,   877,   789,   788,   787,
     625,   624,    48,     0,   614,   608,   615,     0,     0,     0
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   532,
     853,   533,   534,  1395,   959,  1296,   535,   536,  1015,   199,
     438,   439,   440,   200,   443,   444,   201,   202,   846,   203,
     204,   537,   538,   539,   540,   476,   456,   457,   459,   460,
     205,   206,   848,   951,   462,   463,   465,   466,   468,   469,
     207,  1178,  1211,  1179,  1240,  1241,  1016,  1017,  1018,  1019,
    1020,  1021,  1427,  1151,   541,   542,  1022,  1287,   924,   925,
     926,  1585,  1505,  1506,   927,   928,  1404,  1405,  1023,  1184,
    1117,  1118,  1119,  1024,  1025,  1026,  1027,   932,  1028,  1321,
    1029,  1030,  1121,   935,  1031,  1032,  1199,   936,   937,   938,
    1101,  1518,  1519,   939
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1136
static const yytype_int16 yypact[] =
{
    2348,  -258,     8,     9,  -225,  -167,  -154,  -128,  -121,  -107,
   -1136,   -93,   -89,   -83,   -79,   -57,   -54,   -34,     1,    14,
      19,    28,   131,   134,   287,   350,   366,   395,   414,   417,
      25,    27,    37,    43,   215,   296,   589,   661,   709,   721,
     769,   772,   785,   800,   803,   846,   847,   860,   864,   865,
     894,   895,   899,   903,   907,   909,   920,   933,   936,   937,
     939,   940,   942,   943,   466,   487,   492,   511,   518,   552,
     561,   575,   584,   596,   597,   601,   602,   666,   702,   710,
     714,   716,   744,   747,   759,   763,    86,    29,    47,   229,
     782,   801,   830,   831,   845,   848,   849,   853,   877,   889,
     890,   908,   912,   918,   922,   925,   926,   938,   945,   955,
     959,   965,   944,   950,   951,   961,   970,   974,   983,  1017,
    1021,  1028,  1031,  1036,  1039,  1048,  1094,  1099,  1101,  1102,
    1104,  1105,  1107,  1113,  1114,  1115,  1116,  1117,  1118,  1120,
    1121,  1123,  1124,  1125,  1126,  1127,  1128,  1129,  1130,  1181,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1191,  1218,  1219,
    1225,  1226,   963,  1227,  1228,  1229,  1230,  1231,  1232,  1233,
    1234,  1235,  1237,  1238,    68,  1239,  1240,  1241,  1242,  1243,
    1245,  1246,  1249,   185,   194,   140,   191,   195, -1136, -1136,
   -1136,   303,  1471, -1136,   209,   542,   861,   934,   958, -1136,
   -1136, -1136,  -261, -1136, -1136,   387, -1136, -1136, -1136, -1136,
     530, -1136,   139,   167,   836,   284,   217,   252,   321,   256,
     306,   309,   342,   206,   220,   435,   225,   446,   231,   241,
     242,   247,    41,    92,   588,   590,   610, -1136,   640, -1136,
     665, -1136,   684, -1136,  -249, -1136,  -249, -1136,  -249, -1136,
    -249, -1136,   701, -1136,   733, -1136,   738, -1136,   751, -1136,
     761, -1136,   789, -1136,   837, -1136,   886, -1136,  1217, -1136,
    1220, -1136,  1221, -1136,  1222, -1136,  1223, -1136,  1224, -1136,
    1236, -1136,  1255, -1136,  1366, -1136,  1367, -1136,  1368, -1136,
    1369, -1136,  1407, -1136,  1410, -1136,  1411, -1136,  1412, -1136,
    1423, -1136,  1424, -1136,  1425,   324,   614,   515,   621,   632,
     638,   644,   646,   647,   659,   325,   326,   327,   329,   330,
     332,   353,   660,   662,   264,   266,   667, -1136, -1136, -1136,
     268, -1136, -1136,  1215, -1136,   269, -1136,   668,   670,   205,
     226,   235,   236,   239,   671,   672,   673,   674,   359,   432,
     457,   240,   675,   678,   679,   680,    26,   682,   685, -1136,
    1426, -1136,  1427, -1136,  1428, -1136,  1429,   687,   689,   690,
     691,   692,   693,   695,   696,   697,   698,   703,   704,   706,
     707,   712,   717,   718,  1018,   722,   728,   731,   732,   270,
     272,   273,   734,   735,   737,    69,   740,   741,   750,   753,
     754,   755,   758,   766,   771,   777,   779,   780,   790,   791,
     792,   254,   304, -1136,  1430,   793,   794,   795,   796,   799,
     811,   817,   274,   818,   819,   821,   -20,  1431,  1432,   458,
     598,   822,   823,   824,   825, -1136, -1136, -1136, -1136,  1211,
    1216, -1136, -1136, -1136,  1455, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136,  -258, -1136,    45,    24,   654, -1136,    63,  1421,
   -1136,    72,  1422, -1136,    76,  1452, -1136,    39,  1214, -1136,
     -25,  1438, -1136, -1136, -1136, -1136,  1450, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1439,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136,  1469, -1136, -1136, -1136, -1136,
    -179,  1463, -1136,  1451,  1453,  1075,  1448, -1136, -1136, -1136,
   -1136, -1136,  -195, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
    1461, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136,  1469, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1267,  1268,
    1270, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136,   483,  1473,   483, -1136,   530,
   -1136, 11401, -1136,   530, 11401, -1136,   530, 11401, -1136,   530,
   11401, -1136,  1464, -1136, -1136, -1136,  1271,  1459, 11401,    42,
   -1136,  1475,  1468,  1467,  1466,   437,   880, -1136,  -179,   298,
     301,  1476,   275,   276,   277, -1136, -1136, -1136,  1470,    55,
      65,    70,    80,    88, 10340, 10675, 10760, -1136,    93,    94,
      96,  1489,    98,   108,   109,   117,   119,   120,   121,   125,
    1490,   127,   135,   138,   141,  1491,  1492,  1493,  1494,  1495,
   10845,   151,   152,   154,  1504,  1515,  1517,  1518,  6100, 10845,
     155,   157,   158,   166,   169, -1136, -1136, -1136, -1136,   172,
   -1136, -1136, -1136,   107,  3420, -1136, -1136, -1136, -1136,   998,
   -1136, -1136, -1136, -1136, -1136,  1272,  1474,   173, -1136,  1521,
    1526,  3492,  1527,  3581,  1531,  3828,  1532,   199,  1481,  3917,
   -1136,  1520,  1487,  -179, -1136, -1136, -1136, -1136, -1136, -1136,
    1539,  1552, -1136, -1136, -1136, -1136, -1136,  1540, -1136, -1136,
   -1136, -1136, -1136, -1136,  1558, -1136,    46, -1136,   123, -1136,
     144, -1136,   150, -1136,   156,   655, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136,   767, -1136,   767,
   -1136,   867, -1136, -1136,  1439, -1136, -1136,  6187,  6274,  6611,
    1560,  1561, -1136,  5252, 11334, -1136,   784, -1136,   870, -1136,
     884, -1136, -1136, -1136,   998, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136,  6698,  2813,  5589,  2813,  5676,  2813, -1136,   258,
   -1136,   278, -1136,  6785,  1570, -1136,   279, -1136,   280, -1136,
     282, -1136,   285, -1136,   829, -1136,   833, -1136,  1564, -1136,
     201,  1565, -1136,   286, -1136,   288, -1136,   289, -1136,   290,
    1574,  1585,  1587,   161,   859,  7122, 10273, -1136,   189, -1136,
     835, -1136,    23,  1588,  1589,  1591,  1600, -1136,   993, 10273,
   -1136,   291, -1136,   293, -1136,   642, -1136,   649, -1136,   699,
   -1136,  1604, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1614, -1136,  1602,
   -1136, 10845, -1136, -1136,    11, -1136,  1605, -1136,  1613, -1136,
    1626, -1136,  1627, -1136,  1704,  1705,   -25, -1136, 11401,  1642,
   -1136,  -149,  1643,  -253, 11401,  1634,  -156, -1136,   -19, -1136,
     506,   891,  1654,   551,   705,   719,   999,  1656,   820,   826,
     911,  1000,  1657,   919,   923,   994,  1003,  1658,  1008,  1011,
    1012,  1015, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  7209,
    5066,  5159, -1136,  1196,  1652, -1136, -1136, -1136, -1136, -1136,
   -1136,  7296,  7633,  1660, -1136,  1712,  1713,  1717,  1718,  1060,
    1676,  1681,  3986, -1136,  7720, -1136, -1136, -1136, -1136, -1136,
    7807,  8144, -1136,  2672,  1693, -1136, -1136,  8231,  8318,  8655,
    8742, 10845, 10845, 10845, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136,  8829,  9166,  9253,  9340,  9677,
    9764,  9851, -1136, -1136,  1698,  1701,  1700,  1702,  1703,  1723,
      52,  1135,  1725,  1726,  1727,  1729,  1738,  1739,  1743,  1744,
    1745,  1753,  1754,  1755,  1756, -1136,  1757, -1136,  1758, -1136,
    1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766, -1136, -1136,
   -1136,  1767,  1791, -1136,  1792,  1793, 11401,  1991, -1136,  1794,
    1795,  1796,  1798,  1799,  1797,  1800,  1802, -1136, -1136, -1136,
   -1136,    35, -1136,  1803,  1714,  1813,  1814,  1815,  1816,  1818,
    1819,  1820,  1822, 10845,  1809,  1821,  2813,  1016, -1136,   998,
   -1136,  1825, -1136, 11401, 11401, 11401, 11401,  1831,  1832,  1870,
    4058,  1841, -1136, -1136,  1829,  1830,  4164, -1136,   -21, -1136,
    1842, -1136,  1843, -1136,   211,   250,  1844, -1136, -1136,   -12,
   -1136,  1845, -1136,  1846, -1136,  1871, -1136, -1136,   658, -1136,
    1872, -1136,  1873, -1136,  1874, -1136, -1136,   663, -1136,  1875,
   -1136,  1876, -1136,  1877, -1136, -1136,   664, -1136,  1878, -1136,
    1881, -1136,  1882, -1136, -1136,  1879,  1069, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136,  1069, -1136, -1136,  1069,
   -1136, -1136, -1136,  1827, -1136,  1886,  1860,  1472,  1869,  2122,
   -1136, -1136, -1136, -1136, -1136, -1136,  1948,  1069, -1136,  1069,
   -1136,  1004, -1136,  2017,  1469,  1810,  1897, -1136,  -168,  1069,
    -266, -1136,  2835, -1136,  2888, -1136,  2908, -1136,  1154,  3017,
    3352,  1193, -1136,   474, -1136,   474, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136,  1069, -1136,  1004, -1136,  1889, -1136, -1136,
    1890, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136,  4394, 11265, -1136, -1136, -1136, -1136, -1136,   438,  -179,
   -1136,  1884,  5763,  1885, -1136, -1136,   749, -1136, 11180, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136,  2813,  1052, -1136,
   -1136, -1136,   483, -1136, -1136,   259,  4500,  4569,  4641,  4730,
   -1136, -1136,  -150, -1136,  1894, -1136, -1136, -1136,  1888,  1891,
    1893,  1895, -1136, -1136, -1136, -1136,  1896,  1898,  1899,  1900,
    1901,  1902,  1903,  1904,  1905,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1940,  1941,  -242,  1652, -1136,
   -1136, -1136, -1136,    64,  1880,  1942,  1945, -1136, -1136, -1136,
   -1136,  1887, -1136,  1944, 10188,  1946,  2813, 11401, -1136, -1136,
    1949,  2352, 10845, -1136,  1952,  1954,  1956, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,  1892,
    1953, -1136, -1136,  1469, -1136, -1136, -1136, -1136,  -149, 11401,
    1950,  1955,  2759,  2828, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136,  2905, 11401, 11401, -1136,  3015,  3245,  3351
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1136, -1136, -1136,  2032, -1136, -1136, -1136, -1136, -1136,  -393,
    1342,  1440,  -210,  1119, -1135, -1136, -1136,  -194,  -215, -1136,
    1477, -1136,  -183, -1136,  1478, -1136, -1136, -1136,  1162, -1136,
   -1136,  -961,  1951,  1768,  1947,  -635, -1136, -1136, -1136, -1136,
   -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136, -1136,
   -1136,  -981, -1136,  -936, -1136, -1136,  1150, -1136, -1136, -1136,
    1151, -1136, -1136,   214,  -640, -1136,  -103, -1082,  -785,  -677,
   -1136,   720,   802, -1136, -1136, -1136,   739, -1136, -1136, -1136,
   -1136,   987, -1011,  -394,  -826, -1136,  -752, -1136, -1136, -1136,
    -609,  -780, -1136, -1136, -1136, -1136,  -110,   237, -1136, -1136,
   -1136, -1136,   743, -1136
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -874
static const yytype_int16 yytable[] =
{
     491,   442,   748,   497,   487,   930,  1332,  1302,   930,   209,
     211,   930,  1317,  1214,   930,  1150,  1180,  1155,  1181,  1160,
    1183,  1165,   930,  1170,  1293,   830,   237,   678,   239,   554,
     329,   555,   843,   556,   208,   557,  1501,  1210,   241,   544,
     841,  1538,   524,   950,   243,   489,   828,  1145,   332,   941,
    1547,   934,   943,  1100,   934,   945,   975,   934,   489,   490,
     934,   470,   489,   949,   832,  1632,   977,   212,   934,   489,
     747,   979,   490,   835,  1521,  1334,   490,   838,   471,   931,
    1204,   981,   931,   490,  1213,   931,  1629,   327,   931,   983,
     586,  1502,  1503,   543,  1038,  1040,   931,  1042,   930,  1045,
     605,   607,   609,   611,   613,   615,   617,  1146,  1102,  1047,
    1049,   482,   483,   484,   485,   930,   859,   930,  1051,   930,
    1053,  1055,  1057,   930,  1152,   213,  1059,   860,  1062,   482,
     483,   484,   485,   661,   663,   665,  1064,   852,   214,  1066,
     477,   445,  1068,  1344,   934,  1157,   525,   526,   527,   528,
     529,  1162,  1077,  1079,  1345,  1081,  1090,  1167,  1092,  1094,
     531,   934,  1281,   934,   215,   934,   957,  1096,   479,   934,
    1098,   216,   931,  1100,  1123,  1601,   958,  1338,  1602,  1339,
     482,   483,   484,   485,  1153,   217,   435,  1195,   930,   931,
    1289,   931,   447,   931,   868,   441,   449,   931,   940,   218,
    1133,   942,  1266,   219,   944,  1158,   637,   506,  1195,   220,
    1195,  1163,  1542,   221,   814,   816,   245,  1168,   492,   964,
     966,   508,   933,   454,   455,   933,   512,   640,   933,  1202,
     334,   933,   516,  1198,   934,   222,   643,   646,   223,   933,
     649,   666,   518,   520,   808,   809,   810,  1106,   522,  1195,
     930,  1544,  1426,   494,  1198,   779,  1198,   498,   224,  1244,
    1595,  1196,   931,   930,  1106,   622,  1106,   624,  1106,   628,
     631,   735,  1106,   737,   739,   800,   968,   970,   972,  1247,
    1253,  1255,  1196,  1257,  1196,   488,  1259,  1270,   918,  1272,
    1274,  1276,  1303,   225,  1305,  1198,   934,   247,  1320,   962,
     844,   845,   965,   451,  1539,   782,   226,   500,  1524,   934,
     502,   227,   930,  1548,  1340,   933,  1341,   238,   930,   240,
     228,   330,   496,  1196,   931,   585,   604,   606,   608,   242,
     610,   612,   933,   614,   933,   244,   933,   931,   486,  1318,
     933,   857,   921,   504,  1322,  -479,  -480,   210,   525,   526,
     527,   528,   529,  1330,   616,   529,   486,   331,   934,  1336,
     660,  -470,   531,  1580,   934,   531,   525,   526,   527,   528,
     529,   676,  1147,  1504,  1148,   529,   930,   530,  -496,  -485,
     531,  1149,  -469,   333,   829,   531,   931,  1462,  -873,  1633,
     426,   976,   931,   529,   525,   526,   527,   528,   529,  1288,
    -475,   978,   833,   531,  1197,   933,   980,   486,   531,  -488,
    1578,   836,  1288,  -492,   328,   839,   982,   525,   526,   527,
     528,   529,   934,   229,   984,  1197,   230,  1197,   530,  1039,
    1041,   531,  1043,   662,  1046,  1183,   510,   929,   956,  1579,
     929,  1103,  1183,   929,  1048,  1050,   929,   514,   676,  1147,
     931,  1154,   529,  1052,   929,  1054,  1056,  1058,   664,   813,
     930,  1060,   531,  1063,   478,   961,  1197,   933,   446,   676,
    1147,  1065,  1159,   529,  1067,   676,  1147,  1069,  1164,   529,
     933,   676,  1147,   531,  1169,   529,  1282,  1078,  1080,   531,
    1082,  1091,   480,  1093,  1095,   531,  1283,   930,   930,   930,
     930,  1491,  1097,  1652,   930,  1099,   934,   246,  -873,  1124,
     930,   436,   489,   437,   525,   526,   527,   528,   529,   448,
     436,   335,   437,   450,  1134,  1106,   490,  1135,   531,   933,
     929,   638,   507,   639,   931,   933,  1267,  1543,  1526,  1527,
    1528,  1529,   493,   934,   934,   934,   934,   929,   509,   929,
     934,   929,   641,   513,   642,   929,   934,   336,   458,   517,
     852,   644,   647,   645,   648,   650,   667,   651,   668,   519,
     521,   931,   931,   931,   931,   523,  1545,   495,   931,   231,
     780,   499,   781,  1245,   931,   436,  1246,   437,   248,   545,
     249,   547,   623,   933,   625,   489,   629,   632,   736,   815,
     738,   740,   801,   969,   971,   973,  1248,  1254,  1256,   490,
    1258,   549,  1634,  1260,  1271,   587,  1273,  1275,  1277,  1304,
     929,  1306,   590,   963,   526,   527,   963,   526,   527,   783,
     784,   501,   489,   592,   503,   489,   489,   489,   489,   594,
     489,   489,   232,   489,   442,   596,   490,   598,   600,   490,
     490,   490,   490,  1106,   490,   490,  1172,   490,   233,  1106,
     602,   618,   251,   620,   489,   930,   930,   505,   626,   633,
     489,   635,   652,   654,   656,   658,   669,   933,   490,   671,
     673,   675,   929,   680,   490,  1290,   682,   234,   688,  1294,
     690,   692,   694,   696,   698,   929,   700,   702,   704,   706,
     930,   930,   930,   930,   708,   710,   235,   712,   714,   236,
     253,   934,   934,   716,   933,   933,   933,   933,   718,   720,
    1552,   933,   255,   727,   472,  1557,  1562,   933,   923,   729,
    1319,   923,   731,   733,   923,   741,   743,   923,   745,   931,
     931,   749,   751,   489,   929,   923,   934,   934,   934,   934,
     929,   753,   957,   957,   755,   757,   759,   490,   305,   761,
     511,   930,   958,   958,  1033,  1035,  1037,   763,   489,   489,
     257,   515,   765,   259,   931,   931,   931,   931,   767,   306,
     769,   771,   490,   490,   307,  1203,   261,  1237,  1238,  1239,
    1076,   773,   775,   777,   786,   788,   790,   792,  1088,  1089,
     794,   263,  1643,   308,   265,  1502,  1503,   934,   929,   436,
     309,   437,   796,   930,  1106,  1288,   930,   930,   798,   802,
     804,   923,   806,   817,   819,   821,   823,   930,   930,   930,
    1261,   930,   930,   930,  1263,   931,  1291,   481,   923,  1342,
     923,  1343,   923,   589,   310,  1268,   923,   267,   269,  1106,
    1106,  1106,  1106,   311,  1653,   473,   474,  1657,   475,   934,
    1284,   271,   934,   934,  1285,   273,   275,   312,  1182,  1658,
    1659,  1205,  1295,   934,   934,   934,   313,   934,   934,   934,
     461,   250,   933,   933,  1349,  1212,  1350,   931,   314,   315,
     931,   931,   929,   316,   317,   277,   279,  1186,  1188,  1190,
     281,   931,   931,   931,   283,   931,   931,   931,   285,   489,
     287,   923,  1308,   546,  1310,   548,  1312,   933,   933,   933,
     933,   289,  1216,   490,   482,   483,   484,   485,  1335,   929,
     929,   929,   929,  1251,   291,   550,   929,   293,   295,   588,
     297,   299,   929,   301,   303,   359,   591,   482,   483,   484,
     485,   361,   363,   252,   464,  1173,  1174,   593,   318,  1175,
    1176,  1177,   365,   595,   413,   551,  1106,  1307,   436,   597,
     437,   599,   601,   923,  1309,   436,  1106,   437,   933,   467,
    1106,  1106,  1106,  1553,   603,   619,   923,   621,  1558,  1563,
     552,   831,   627,   634,   319,   636,   653,   655,   657,   659,
     670,   254,   320,   672,   674,   676,   321,   681,   322,   553,
     683,  1316,   689,   256,   691,   693,   695,   697,   699,   722,
     701,   703,   705,   707,  1311,   436,   558,   437,   709,   711,
     933,   713,   715,   933,   933,   923,   323,   717,  1351,   324,
    1352,   923,   719,   721,   933,   933,   933,   728,   933,   933,
     933,   325,  1353,   730,  1354,   326,   732,   734,   559,   742,
     744,   258,   746,   560,   260,   750,   752,  1173,  1174,  1386,
    1396,  1399,  1176,  1177,   337,   754,   561,   262,   756,   758,
     760,  1407,  1409,   762,  1173,  1174,   562,  1588,  1175,  1176,
    1177,   764,   264,   338,  1417,   266,   766,   929,   929,   923,
    1419,  1421,   768,  1429,   770,   772,  1581,  1432,  1434,  1436,
    1438,  1439,  1440,  1441,   563,   774,   776,   778,   787,   789,
     791,   793,   339,   340,   795,  1443,  1445,  1447,  1449,  1451,
    1453,  1455,   929,   929,   929,   929,   797,   341,   268,   270,
     342,   343,   799,   803,   805,   344,   807,   818,   820,   822,
     824,   486,   272,  1358,  1262,  1359,   274,   276,  1264,  1360,
    1292,  1361,   564,   482,   483,   484,   485,  1173,  1174,   345,
    1173,  1174,  1176,  1177,   486,  1176,  1177,  1206,  1207,  1208,
    1209,   346,   347,   923,  1173,  1174,   278,   280,  1175,  1176,
    1177,   282,  1156,   929,  1161,   284,  1166,  1400,  1171,   286,
     348,   288,  1344,  1517,   349,   525,   526,   527,   528,   529,
     350,   565,   290,  1345,   351,  1574,   530,   352,   353,   531,
     923,   923,   923,   923,  1346,   292,  1347,   923,   294,   296,
     354,   298,   300,   923,   302,   304,   360,   355,   723,   724,
     725,   726,   362,   364,  1362,   929,  1363,   356,   929,   929,
    1200,   357,  1367,   366,  1368,   414,  1369,   358,  1370,   929,
     929,   929,   367,   929,   929,   929,   368,   986,   987,   988,
     989,  1200,   991,  1200,   993,   369,   995,  1107,  1108,  1109,
    1110,  1111,  1112,  1113,  1114,  1115,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,   370,
    1344,  1344,  1200,   371,  1344,  1235,  1236,  1237,  1238,  1239,
     372,  1345,  1345,   373,  1116,  1345,  1344,  1371,   374,  1372,
    1301,   375,  1355,  1364,  1356,  1365,  1373,  1345,  1374,  1594,
     376,  1376,  1596,  1377,  1378,  1380,  1379,  1381,  1382,  1522,
    1383,  1523,  1630,  1217,  1218,  1219,  1220,  1221,  1222,  1223,
    1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,
    1234,  1235,  1236,  1237,  1238,  1239,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1592,   377,  1593,   923,   923,
     486,   378,  1586,   379,   380,  1411,   381,   382,  1591,   383,
     525,   526,   527,   528,   529,   384,   385,   386,   387,   388,
     389,   530,   390,   391,   531,   392,   393,   394,   395,   396,
     397,   398,   399,   923,   923,   923,   923,  1428,  1217,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,
    1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,
    1239,  1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1463,    -2,   452,   400,  1586,   401,   402,   403,   404,   405,
     406,   407,  1517,   408,   923,   -11,   -11,   -13,     2,     3,
     -16,   -18,   -20,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     4,
     409,   410,     5,     6,     7,     8,     9,   411,   412,   415,
     416,   417,   418,   419,   420,   421,   422,   423,    10,   424,
     425,   427,   428,   429,   430,   431,   923,   432,   433,   923,
     923,   434,   566,   630,   825,   567,   568,   569,   570,   571,
     923,   923,   923,   842,   923,   923,   923,   858,   826,   862,
     863,   572,   864,   947,  1120,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
     573,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   574,   575,   576,   577,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   578,   173,   174,   579,   580,   581,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   582,   583,
     584,   684,   685,   686,   687,   785,   811,   812,   834,   837,
     185,   186,   187,   847,   850,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,   827,   840,
     849,   851,   529,   855,   861,   856,   946,   188,   866,   948,
     952,   953,   954,  1136,   967,   189,   955,  1570,  1122,  1139,
     974,  1100,   190,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  1044,  1061,  1070,  1071,  1072,
    1073,  1074,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    1083,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  1084,  -575,  1085,  1086,  1125,  -575,  1138,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  -575,  1126,  1128,  -575,  -575,
    -575,  1130,  1132,  1143,  -575,  -575,  -575,  -575,  -575,  -575,
    1100,  1141,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  1142,  1144,  1191,  1192,  1252,  1265,
    1269,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  1278,
    -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    1279,  -543,  1280,  1297,  1298,  -543,  1299,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  -543,  1300,  1314,  -543,  -543,  -543,
    1313,  1315,  1323,  -543,  -543,  -543,  -543,  -543,  -543,  1182,
    1324,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  1325,  1326,  1327,  1328,  1331,  1333,  1337,
    -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  1403,  -547,
    -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  1348,
    -547,  1357,  1366,  1375,  -547,  1410,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  -547,  -646,  -647,  -547,  -547,  -547,  -658,
    -659,  1412,  -547,  -547,  -547,  -547,  -547,  -547,  1182,  1413,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  1430,  1456,  1457,  1458,  1460,  1459,  1492,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  1508,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  1461,  -564,
    1464,  1465,  1466,  -564,  1467,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  1468,  1469,  -564,  -564,  -564,  1470,  1471,
    1472,  -564,  -564,  -564,  -564,  -564,  -564,  -575,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,  1481,  1482,  1483,  1484,
    1485,  1486,  1487,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,  -575,
    -575,  -575,  -575,  -575,  -575,  -575,  1488,  1489,  1490,  1493,
    1494,  1495,  -575,  1496,  1497,  1116,  -575,  1500,  1507,  1498,
    -575,  -575,  1499,  -575,  -575,  -575,  -873,  -575,  1509,  1510,
    1511,  1512,  -575,  1513,  1514,  1515,  -543,  1516,  1525,  1530,
    1531,  1521,  1532,  1534,  1535,  1536,  1567,  1540,  1541,  1546,
    1549,  1550,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,  -543,
    -543,  -543,  -543,  -543,  -543,  1569,  1551,  1554,  1555,  1556,
    1559,  1560,  1561,  1564,  1571,  -543,  1565,  1566,  1568,  -543,
    -543,  1573,  -543,  -543,  -543,  -873,  -543,  1575,  1576,  1603,
    1635,  -543,  1582,  1604,   453,  -547,  1605,  1587,  1606,  1638,
    1607,  1608,  1650,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,  -547,
    -547,  -547,  -547,  -547,  1617,  1618,  1619,  1620,  1621,  1622,
    1623,  1624,  1625,  1626,  -547,  1627,  1628,  1636,  -547,  -547,
    1637,  -547,  -547,  -547,  1644,  -547,  1639,  1647,  1642,  1648,
    -547,  1649,  1654,  1651,  -564,  1140,   960,  1655,  1329,   854,
    1398,  1520,   865,   679,  1641,   867,   677,  1631,  1589,     0,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,  -564,
    -564,  -564,  -564,  1401,  1402,  1646,     0,     0,     0,     0,
       0,     0,     0,  -564,     0,     0,     0,  -564,  -564,     1,
    -564,  -564,  -564,     0,  -564,     0,     0,     0,     0,  -564,
       0,     0,   -11,   -11,   -13,     2,     3,   -16,   -18,   -20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     5,
       6,     7,     8,     9,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,     0,
       0,     0,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,  1572,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,     0,     0,
       0,     0,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
     173,   174,     0,     0,     0,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   185,   186,   187,
       0,     0,     0,     0,     0,  1217,  1218,  1219,  1220,  1221,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,     0,
       0,     0,     0,  1422,   188,   869,   870,   871,   872,   873,
       0,     0,   189,     0,   878,   879,   880,  1645,     0,   190,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1423,  1002,
    1656,     0,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,  -607,  -607,   909,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,  1104,
       0,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,  -609,  -609,   909,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,     0,     0,
       0,     0,     0,     0,     0,     0,  1104,     0,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,   918,
    1003,   900,     0,   901,   902,   903,   904,   905,   906,   907,
     908,  -611,  -611,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,  1424,  1425,     0,
    1012,   529,   920,   921,     0,     0,     0,     0,  1075,  1014,
       0,   531,     0,     0,     0,     0,  1104,     0,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,   918,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,   900,     0,   901,   902,   903,   904,   905,   906,   907,
     908,  -605,  -605,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   919,     0,     0,     0,   920,
     921,     0,     0,   922,     0,     0,     0,  -607,     0,     0,
       0,     0,     0,     0,     0,   918,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,
    1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,
    1239,     0,     0,     0,   919,     0,     0,     0,   920,   921,
       0,     0,   922,     0,     0,     0,  -609,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,
    1236,  1237,  1238,  1239,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,
    1236,  1237,  1238,  1239,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,     0,  -611,     0,     0,  1104,     0,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,   900,   918,   901,   902,   903,   904,   905,   906,   907,
     908,  -612,  -612,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,  1222,  1223,  1224,  1225,  1226,
    1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,
    1237,  1238,  1239,     0,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,  1104,  -605,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,  -606,  -606,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,  1104,     0,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,   909,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
       0,     0,     0,  1104,     0,   869,   870,   871,   872,   873,
     874,   875,   876,   877,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,   918,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,   900,     0,
     901,   902,   903,   904,   905,   906,   907,   908,     0,     0,
     909,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,  1104,  -612,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,   918,   901,
     902,   903,   904,   905,   906,   907,   908,     0,     0,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922,     0,     0,     0,  -606,
       0,     0,     0,     0,     0,     0,     0,   918,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,     0,
     920,   921,     0,     0,   922,     0,     0,     0,  1105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   919,     0,
       0,     0,   920,   921,     0,     0,   922,     0,     0,  1104,
    1127,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,   918,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,   900,     0,   901,   902,   903,   904,
     905,   906,   907,   908,     0,     0,   909,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922,     0,     0,  1104,  1129,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,   900,     0,   901,   902,   903,   904,   905,
     906,   907,   908,     0,     0,   909,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,  1104,     0,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,   900,     0,   901,   902,   903,   904,   905,   906,
     907,   908,     0,     0,   909,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,     0,     0,     0,  1104,
       0,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,   900,   918,   901,   902,   903,   904,
     905,   906,   907,   908,     0,     0,   909,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   919,     0,     0,     0,   920,   921,
       0,     0,   922,     0,     0,  1104,  1131,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,   918,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,   909,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   919,     0,     0,     0,   920,   921,     0,
       0,   922,     0,     0,     0,  1137,     0,     0,     0,     0,
       0,     0,     0,   918,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   919,     0,     0,     0,   920,   921,     0,     0,
     922,     0,     0,     0,  1414,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   919,     0,     0,     0,   920,   921,
       0,     0,   922,     0,     0,  1104,  1533,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
     900,   918,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,   909,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   920,   921,     0,     0,   922,     0,
       0,  1104,  1537,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,   900,     0,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,   909,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
    1104,     0,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,   900,     0,   901,   902,   903,
     904,   905,   906,   907,   908,     0,     0,   909,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,     0,
       0,     0,  1104,     0,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,   918,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,     0,     0,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   920,   921,     0,     0,   922,     0,
       0,  1104,  1577,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,   900,   918,   901,   902,
     903,   904,   905,   906,   907,   908,     0,     0,   909,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,     0,
     920,   921,     0,     0,   922,     0,     0,     0,  1597,     0,
       0,     0,     0,     0,     0,     0,   918,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   919,     0,     0,     0,   920,
     921,     0,     0,   922,     0,     0,     0,  1598,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922,     0,     0,     0,  1599,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,     0,
     920,   921,     0,     0,   922,     0,     0,  1387,  1600,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1388,  1389,  1390,  1391,  1392,  1393,
    1397,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1388,  1389,  1390,
    1391,  1392,  1393,  1193,     0,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,  1394,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,     0,  1075,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,  1394,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,   920,
     921,     0,     0,     0,     0,  1075,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,
    1012,     0,   920,   921,     0,     0,     0,  1194,  1075,  1014,
    1193,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1193,     0,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1583,     0,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,     0,     0,
       0,     0,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,   920,
     921,     0,     0,     0,  1242,  1075,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,  1243,  1075,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,  1584,     0,  1005,
       0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,
       0,  1012,     0,   920,   921,     0,     0,     0,     0,  1075,
    1014,  1087,     0,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1185,     0,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,     0,     0,   901,   902,   903,   904,   905,
     906,   907,     0,     0,     0,     0,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,  1187,     0,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   907,     0,
       0,     0,     0,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,   490,   919,     0,  1012,     0,   920,   921,     0,
       0,     0,     0,  1075,  1014,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   918,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,     0,     0,     0,
    1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,
     919,     0,  1012,     0,   920,   921,     0,     0,     0,     0,
    1075,  1014,  1189,     0,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,     0,     0,   901,
     902,   903,   904,   905,   906,   907,     0,     0,     0,     0,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1215,
       0,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,     0,     0,   901,   902,   903,   904,
     905,   906,   907,     0,     0,     0,     0,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1249,     0,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,  1003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,     0,  1005,     0,  1006,
    1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,
       0,   920,   921,     0,     0,     0,     0,  1075,  1014,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,
       0,  1010,  1011,   490,   919,     0,  1012,     0,   920,   921,
       0,     0,     0,     0,  1075,  1014,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,  1250,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1075,  1014,  1193,     0,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1384,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1406,     0,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,
    1012,     0,   920,   921,     0,     0,     0,     0,  1075,  1014,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,  1385,     0,  1012,     0,   920,
     921,     0,     0,     0,     0,  1075,  1014,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,     0,  1075,  1014,  1408,     0,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,     0,     0,
       0,     0,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1415,     0,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1416,  1002,  1418,     0,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,     0,     0,   901,   902,   903,   904,   905,
     906,   907,     0,     0,     0,     0,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,     0,  1005,
       0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,
       0,  1012,     0,   920,   921,     0,     0,     0,     0,  1075,
    1014,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,   490,   919,     0,  1012,     0,   920,   921,     0,
       0,     0,     0,  1075,  1014,  1420,     0,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   907,     0,
       0,     0,     0,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1431,     0,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,     0,     0,   901,
     902,   903,   904,   905,   906,   907,     0,     0,     0,     0,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1433,
       0,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,     0,     0,   901,   902,   903,   904,
     905,   906,   907,     0,     0,     0,     0,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   918,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,     0,     0,     0,
    1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,
     919,     0,  1012,     0,   920,   921,     0,     0,     0,     0,
    1075,  1014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,  1003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,     0,  1005,     0,  1006,
    1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,
       0,   920,   921,     0,     0,     0,     0,  1075,  1014,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,
       0,  1010,  1011,   490,   919,     0,  1012,     0,   920,   921,
       0,     0,     0,     0,  1075,  1014,  1435,     0,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1437,     0,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   878,   879,   880,     0,     0,     0,
       0,     0,     0,     0,   881,   882,   883,   884,   885,   886,
     887,   888,     0,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,     0,   899,     0,     0,     0,     0,     0,
     901,   902,   903,   904,   905,   906,   907,     0,     0,     0,
       0,   910,   911,     0,     0,     0,   912,   913,   914,   915,
     916,   917,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1442,     0,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   878,   879,   880,     0,     0,     0,     0,     0,     0,
       0,   881,   882,   883,   884,   885,   886,   887,   888,     0,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
       0,   899,     0,     0,     0,     0,     0,   901,   902,   903,
     904,   905,   906,   907,     0,     0,     0,     0,   910,   911,
       0,     0,     0,   912,   913,   914,   915,   916,   917,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,   919,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1075,  1014,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1004,     0,     0,     0,     0,  1005,     0,
    1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,
    1012,     0,   920,   921,     0,     0,     0,     0,  1075,  1014,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,  1003,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,  1008,
    1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,   920,
     921,     0,     0,     0,     0,  1075,  1014,  1444,     0,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,   881,   882,
     883,   884,   885,   886,   887,   888,     0,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,     0,   899,     0,
       0,     0,     0,     0,   901,   902,   903,   904,   905,   906,
     907,     0,     0,     0,     0,   910,   911,     0,     0,     0,
     912,   913,   914,   915,   916,   917,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1446,     0,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,     0,
       0,   901,   902,   903,   904,   905,   906,   907,     0,     0,
       0,     0,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1448,     0,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1004,     0,     0,
       0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,
    1011,   490,   919,     0,  1012,     0,   920,   921,     0,     0,
       0,     0,  1075,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1004,     0,     0,     0,     0,  1005,
       0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,   919,
       0,  1012,     0,   920,   921,     0,     0,     0,     0,  1075,
    1014,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,  1450,     0,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   878,
     879,   880,     0,     0,     0,     0,     0,     0,     0,   881,
     882,   883,   884,   885,   886,   887,   888,     0,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,     0,   899,
       0,     0,     0,     0,     0,   901,   902,   903,   904,   905,
     906,   907,     0,     0,     0,     0,   910,   911,     0,     0,
       0,   912,   913,   914,   915,   916,   917,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,  1452,     0,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
       0,     0,   901,   902,   903,   904,   905,   906,   907,     0,
       0,     0,     0,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1454,     0,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,     0,     0,   901,
     902,   903,   904,   905,   906,   907,     0,     0,     0,     0,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,   490,   919,     0,  1012,     0,   920,   921,     0,
       0,     0,     0,  1075,  1014,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   918,  1003,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,     0,     0,     0,
    1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,   490,
     919,     0,  1012,     0,   920,   921,     0,     0,     0,     0,
    1075,  1014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,  1003,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1004,     0,     0,     0,     0,  1005,     0,  1006,
    1007,  1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,
       0,   920,   921,     0,     0,     0,     0,  1075,  1014,  1640,
       0,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     878,   879,   880,     0,     0,     0,     0,     0,     0,     0,
     881,   882,   883,   884,   885,   886,   887,   888,     0,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,     0,
     899,     0,     0,     0,     0,     0,   901,   902,   903,   904,
     905,   906,   907,     0,     0,     0,     0,   910,   911,     0,
       0,     0,   912,   913,   914,   915,   916,   917,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,     0,     0,
       0,     0,     0,     0,     0,   881,   882,   883,   884,   885,
     886,   887,   888,     0,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,     0,   899,     0,     0,     0,   900,
       0,   901,   902,   903,   904,   905,   906,   907,   908,     0,
       0,   909,   910,   911,     0,     0,     0,   912,   913,   914,
     915,   916,   917,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   918,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1004,
       0,     0,     0,     0,  1005,     0,  1006,  1007,  1008,  1009,
       0,  1010,  1011,   490,   919,     0,  1012,     0,   920,   921,
       0,     0,     0,     0,  1075,  1014,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     918,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   919,
       0,     0,     0,   920,   921,     0,     0,   922,     0,     0,
    1286,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1013,  1014,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,     0,     0,   901,   902,   903,   904,   905,   906,   907,
       0,     0,     0,     0,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,   919,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1034,  1014,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   918,  1003,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,   490,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1036,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,     0,     0,     0,
       0,  1005,     0,  1006,  1007,  1008,  1009,     0,  1010,  1011,
     490,   919,     0,  1012,     0,   920,   921,     0,     0,     0,
       0,  1075,  1014,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   878,   879,   880,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,   887,   888,
       0,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,     0,   899,     0,     0,     0,     0,     0,   901,   902,
     903,   904,   905,   906,   907,     0,     0,     0,     0,   910,
     911,     0,     0,     0,   912,   913,   914,   915,   916,   917,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
       0,     0,     0,     0,     0,     0,     0,   881,   882,   883,
     884,   885,   886,   887,   888,     0,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,     0,   899,     0,     0,
       0,   900,     0,   901,   902,   903,   904,   905,   906,   907,
     908,     0,     0,   909,   910,   911,     0,     0,     0,   912,
     913,   914,   915,   916,   917,  1201,     0,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,     0,
       0,     0,     0,     0,     0,     0,   881,   882,   883,   884,
     885,   886,   887,   888,     0,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,     0,   899,     0,     0,     0,
     900,     0,   901,   902,   903,   904,   905,   906,   907,   908,
       0,     0,   909,   910,   911,     0,     0,     0,   912,   913,
     914,   915,   916,   917,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,     0,     0,     0,     0,
       0,     0,     0,   881,   882,   883,   884,   885,   886,   887,
     888,     0,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,     0,   899,     0,     0,     0,   900,     0,   901,
     902,   903,   904,   905,   906,   907,   908,   918,  1003,   909,
     910,   911,     0,     0,     0,   912,   913,   914,   915,   916,
     917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1004,     0,     0,     0,     0,  1005,     0,  1006,  1007,
    1008,  1009,     0,  1010,  1011,  1590,   919,     0,  1012,     0,
     920,   921,     0,     0,     0,     0,  1075,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,   920,   921,     0,     0,   922,
       0,     0,  1286,     0,     0,     0,     0,     0,     0,     0,
       0,   918,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     919,     0,     0,     0,   920,   921,     0,     0,   922,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,   920,   921,     0,     0,   922
};

static const yytype_int16 yycheck[] =
{
     215,   184,   395,   218,   214,   831,  1141,  1089,   834,     1,
       1,   837,     1,  1024,   840,   976,   997,   978,   999,   980,
    1001,   982,   848,   984,     1,     1,     1,     1,     1,   244,
       1,   246,    57,   248,   292,   250,     1,  1018,     1,   233,
       1,    62,     1,     1,     1,   311,     1,     1,     1,   834,
      62,   831,   837,     1,   834,   840,     1,   837,   311,   325,
     840,   322,   311,   848,     1,     1,     1,   292,   848,   311,
       1,     1,   325,     1,   340,   328,   325,     1,   339,   831,
    1016,     1,   834,   325,  1020,   837,   328,     1,   840,     1,
     305,    56,    57,     1,     1,     1,   848,     1,   924,     1,
     315,   316,   317,   318,   319,   320,   321,    61,     1,     1,
       1,    88,    89,    90,    91,   941,   311,   943,     1,   945,
       1,     1,     1,   949,     1,   292,     1,   322,     1,    88,
      89,    90,    91,   348,   349,   350,     1,   530,   292,     1,
       1,     1,     1,   311,   924,     1,   325,   326,   327,   328,
     329,     1,     1,     1,   322,     1,     1,     1,     1,     1,
     339,   941,     1,   943,   292,   945,   315,     1,     1,   949,
       1,   292,   924,     1,     1,   325,   325,   333,   328,   335,
      88,    89,    90,    91,    61,   292,     1,  1013,  1014,   941,
       1,   943,     1,   945,   829,     1,     1,   949,   833,   292,
       1,   836,     1,   292,   839,    61,     1,     1,  1034,   292,
    1036,    61,     1,   292,   429,   430,     1,    61,     1,   859,
     860,     1,   831,    14,    15,   834,     1,     1,   837,  1014,
       1,   840,     1,  1013,  1014,   292,     1,     1,   292,   848,
       1,     1,     1,     1,   264,   265,   266,   924,     1,  1075,
    1076,     1,  1213,     1,  1034,     1,  1036,     1,   292,     1,
       1,  1013,  1014,  1089,   941,     1,   943,     1,   945,     1,
       1,     1,   949,     1,     1,     1,     1,     1,     1,     1,
       1,     1,  1034,     1,  1036,     1,     1,     1,   277,     1,
       1,     1,     1,   292,     1,  1075,  1076,     1,  1124,     1,
     325,   326,     1,     0,   325,     1,   292,     1,  1319,  1089,
       1,   292,  1138,   325,   333,   924,   335,   292,  1144,   292,
     292,   292,     1,  1075,  1076,     1,     1,     1,     1,   292,
       1,     1,   941,     1,   943,   292,   945,  1089,   315,   328,
     949,   535,   331,     1,  1124,   337,   337,   339,   325,   326,
     327,   328,   329,  1138,     1,   329,   315,   328,  1138,  1144,
       1,   337,   339,  1498,  1144,   339,   325,   326,   327,   328,
     329,   325,   326,   338,   328,   329,  1202,   336,   339,   337,
     339,   335,   337,   336,   339,   339,  1138,   335,   336,   325,
     322,   336,  1144,   329,   325,   326,   327,   328,   329,  1076,
     337,   336,   339,   339,  1013,  1014,   336,   315,   339,   337,
    1492,   339,  1089,   337,   328,   339,   336,   325,   326,   327,
     328,   329,  1202,   292,   336,  1034,   292,  1036,   336,   336,
     336,   339,   336,     1,   336,  1416,     1,   831,     1,     1,
     834,   334,  1423,   837,   336,   336,   840,     1,   325,   326,
    1202,   328,   329,   336,   848,   336,   336,   336,     1,     1,
    1286,   336,   339,   336,   325,   858,  1075,  1076,   328,   325,
     326,   336,   328,   329,   336,   325,   326,   336,   328,   329,
    1089,   325,   326,   339,   328,   329,   325,   336,   336,   339,
     336,   336,   325,   336,   336,   339,   335,  1323,  1324,  1325,
    1326,  1286,   336,  1638,  1330,   336,  1286,   292,   336,   336,
    1336,   326,   311,   328,   325,   326,   327,   328,   329,   328,
     326,   292,   328,   328,   325,  1202,   325,   328,   339,  1138,
     924,   326,   326,   328,  1286,  1144,   335,   326,  1323,  1324,
    1325,  1326,   325,  1323,  1324,  1325,  1326,   941,   328,   943,
    1330,   945,   326,   328,   328,   949,  1336,   328,    16,   328,
     953,   326,   326,   328,   328,   326,   326,   328,   328,   328,
     328,  1323,  1324,  1325,  1326,   328,   326,   325,  1330,   292,
     326,   325,   328,   325,  1336,   326,   328,   328,   292,     1,
       1,     1,   328,  1202,   328,   311,   328,   328,   328,     1,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   325,
     328,     1,  1573,   328,   328,     1,   328,   328,   328,   328,
    1014,   328,     1,   325,   326,   327,   325,   326,   327,   325,
     326,   325,   311,     1,   325,   311,   311,   311,   311,     1,
     311,   311,   292,   311,   827,     1,   325,     1,     1,   325,
     325,   325,   325,  1330,   325,   325,     1,   325,   292,  1336,
       1,     1,     1,     1,   311,  1491,  1492,   325,     1,     1,
     311,     1,     1,     1,     1,     1,     1,  1286,   325,     1,
       1,     1,  1076,     1,   325,  1078,     1,   292,     1,  1082,
       1,     1,     1,     1,     1,  1089,     1,     1,     1,     1,
    1526,  1527,  1528,  1529,     1,     1,   292,     1,     1,   292,
       1,  1491,  1492,     1,  1323,  1324,  1325,  1326,     1,     1,
      62,  1330,     1,     1,   337,    62,    62,  1336,   831,     1,
    1124,   834,     1,     1,   837,     1,     1,   840,     1,  1491,
    1492,     1,     1,   311,  1138,   848,  1526,  1527,  1528,  1529,
    1144,     1,   315,   315,     1,     1,     1,   325,   292,     1,
     325,  1587,   325,   325,   874,   875,   876,     1,   311,   311,
       1,   325,     1,     1,  1526,  1527,  1528,  1529,     1,   292,
       1,     1,   325,   325,   292,     1,     1,   313,   314,   315,
     900,     1,     1,     1,     1,     1,     1,     1,   908,   909,
       1,     1,  1587,   292,     1,    56,    57,  1587,  1202,   326,
     292,   328,     1,  1639,  1491,  1492,  1642,  1643,     1,     1,
       1,   924,     1,     1,     1,     1,     1,  1653,  1654,  1655,
       1,  1657,  1658,  1659,     1,  1587,     1,     1,   941,   333,
     943,   335,   945,   328,   292,  1060,   949,     1,     1,  1526,
    1527,  1528,  1529,   292,  1639,   325,   326,  1642,   328,  1639,
       1,     1,  1642,  1643,  1074,     1,     1,   292,     1,  1654,
    1655,     1,  1082,  1653,  1654,  1655,   292,  1657,  1658,  1659,
      19,   292,  1491,  1492,   333,     1,   335,  1639,   292,   292,
    1642,  1643,  1286,   292,   292,     1,     1,  1007,  1008,  1009,
       1,  1653,  1654,  1655,     1,  1657,  1658,  1659,     1,   311,
       1,  1014,  1095,   325,  1097,   325,  1099,  1526,  1527,  1528,
    1529,     1,  1032,   325,    88,    89,    90,    91,  1143,  1323,
    1324,  1325,  1326,  1043,     1,   325,  1330,     1,     1,   325,
       1,     1,  1336,     1,     1,     1,   325,    88,    89,    90,
      91,     1,     1,   292,    20,   300,   301,   325,   292,   304,
     305,   306,     1,   325,     1,   325,  1643,   325,   326,   325,
     328,   325,   325,  1076,   325,   326,  1653,   328,  1587,    21,
    1657,  1658,  1659,   325,   325,   325,  1089,   325,   325,   325,
     325,   337,   325,   325,   292,   325,   325,   325,   325,   325,
     325,   292,   292,   325,   325,   325,   292,   325,   292,   325,
     325,  1121,   325,   292,   325,   325,   325,   325,   325,     1,
     325,   325,   325,   325,   325,   326,   325,   328,   325,   325,
    1639,   325,   325,  1642,  1643,  1138,   292,   325,   333,   292,
     335,  1144,   325,   325,  1653,  1654,  1655,   325,  1657,  1658,
    1659,   292,   333,   325,   335,   292,   325,   325,   325,   325,
     325,   292,   325,   325,   292,   325,   325,   300,   301,  1179,
    1180,  1181,   305,   306,   292,   325,   325,   292,   325,   325,
     325,  1191,  1192,   325,   300,   301,   325,   338,   304,   305,
     306,   325,   292,   292,  1204,   292,   325,  1491,  1492,  1202,
    1210,  1211,   325,  1213,   325,   325,  1499,  1217,  1218,  1219,
    1220,  1221,  1222,  1223,   325,   325,   325,   325,   325,   325,
     325,   325,   292,   292,   325,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1526,  1527,  1528,  1529,   325,   292,   292,   292,
     292,   292,   325,   325,   325,   292,   325,   325,   325,   325,
     325,   315,   292,   333,   325,   335,   292,   292,   325,   333,
     325,   335,   325,    88,    89,    90,    91,   300,   301,   292,
     300,   301,   305,   306,   315,   305,   306,   307,   308,   309,
     310,   292,   292,  1286,   300,   301,   292,   292,   304,   305,
     306,   292,   978,  1587,   980,   292,   982,     1,   984,   292,
     292,   292,   311,  1313,   292,   325,   326,   327,   328,   329,
     292,   325,   292,   322,   292,  1430,   336,   292,   292,   339,
    1323,  1324,  1325,  1326,   333,   292,   335,  1330,   292,   292,
     292,   292,   292,  1336,   292,   292,   292,   292,   220,   221,
     222,   223,   292,   292,   333,  1639,   335,   292,  1642,  1643,
    1013,   292,   333,   292,   335,   292,   333,   292,   335,  1653,
    1654,  1655,   292,  1657,  1658,  1659,   292,    71,    72,    73,
      74,  1034,    76,  1036,    78,   292,    80,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   292,
     311,   311,  1075,   292,   311,   311,   312,   313,   314,   315,
     292,   322,   322,   292,   326,   322,   311,   333,   292,   335,
     337,   292,   333,   333,   335,   335,   333,   322,   335,  1522,
     292,   333,  1525,   335,   333,   333,   335,   335,   333,   333,
     335,   335,  1567,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   333,   292,   335,  1491,  1492,
     315,   292,  1502,   292,   292,   335,   292,   292,  1508,   292,
     325,   326,   327,   328,   329,   292,   292,   292,   292,   292,
     292,   336,   292,   292,   339,   292,   292,   292,   292,   292,
     292,   292,   292,  1526,  1527,  1528,  1529,  1213,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     335,     0,     1,   292,  1584,   292,   292,   292,   292,   292,
     292,   292,  1592,   292,  1587,    14,    15,    16,    17,    18,
      19,    20,    21,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    38,
     292,   292,    41,    42,    43,    44,    45,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,    57,   292,
     292,   292,   292,   292,   292,   292,  1639,   292,   292,  1642,
    1643,   292,   325,   328,   333,   325,   325,   325,   325,   325,
    1653,  1654,  1655,   339,  1657,  1658,  1659,   109,   342,   292,
     292,   325,   292,   292,   292,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     325,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   325,   325,   325,   325,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   325,   262,   263,   325,   325,   325,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   337,   337,
     289,   290,   291,   325,   325,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   333,   337,
     340,   322,   329,   342,   333,   342,   332,   326,   325,   340,
     325,   333,   335,   322,   328,   334,   340,   335,   334,   322,
     340,     1,   341,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   336,   336,   336,   336,   336,
     336,   336,    22,    23,    24,    25,    26,    27,    28,    29,
     336,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   336,    42,   336,   336,   334,    46,   337,    48,    49,
      50,    51,    52,    53,    54,    55,   340,   340,    58,    59,
      60,   340,   340,   333,    64,    65,    66,    67,    68,    69,
       1,   342,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,   342,   337,   336,   336,   328,   335,
     335,    22,    23,    24,    25,    26,    27,    28,    29,   335,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     335,    42,   335,   335,   335,    46,   335,    48,    49,    50,
      51,    52,    53,    54,    55,   335,   322,    58,    59,    60,
     336,   339,   337,    64,    65,    66,    67,    68,    69,     1,
     337,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,   337,   337,   261,   261,   325,   325,   335,
      22,    23,    24,    25,    26,    27,    28,    29,   326,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,   335,
      42,   335,   335,   335,    46,   335,    48,    49,    50,    51,
      52,    53,    54,    55,   292,   292,    58,    59,    60,   292,
     292,   335,    64,    65,    66,    67,    68,    69,     1,   338,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,   339,   335,   333,   335,   333,   335,    47,    22,
      23,    24,    25,    26,    27,    28,    29,   333,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   335,    42,
     335,   335,   335,    46,   335,    48,    49,    50,    51,    52,
      53,    54,    55,   335,   335,    58,    59,    60,   335,   335,
     335,    64,    65,    66,    67,    68,    69,   277,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   335,   335,   335,   335,
     335,   335,   322,   335,   335,   326,   326,   335,   335,   342,
     330,   331,   342,   333,   334,   335,   336,   337,   335,   335,
     335,   335,   342,   335,   335,   335,   277,   335,   333,   328,
     328,   340,   292,   322,   335,   335,   339,   325,   325,   325,
     325,   325,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   335,   325,   325,   325,   325,
     325,   325,   325,   325,   335,   326,   325,   325,   322,   330,
     331,   314,   333,   334,   335,   336,   337,   328,   328,   325,
     340,   342,   338,   335,   192,   277,   335,   342,   335,   342,
     335,   335,   340,   335,   335,   335,   335,   335,   335,   335,
     335,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   326,   335,   335,   335,   330,   331,
     335,   333,   334,   335,   335,   337,   342,   335,   342,   335,
     342,   335,   342,   340,   277,   953,   856,   342,  1136,   531,
    1181,  1314,   825,   356,  1584,   827,   355,  1568,  1506,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,  1183,  1183,  1592,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,     1,
     333,   334,   335,    -1,   337,    -1,    -1,    -1,    -1,   342,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   335,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,    -1,
     262,   263,    -1,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   289,   290,   291,
      -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,    -1,    -1,     1,   326,     3,     4,     5,     6,     7,
      -1,    -1,   334,    -1,    12,    13,    14,   335,    -1,   341,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,   277,
     278,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,   330,   331,    -1,    -1,    -1,    -1,   336,   337,
      -1,   339,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   326,    -1,    -1,    -1,   330,
     331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,
      -1,    -1,   334,    -1,    -1,    -1,   338,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,    -1,   338,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,   277,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,     1,   338,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,   277,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,     1,   338,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,   277,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,
      -1,    -1,   330,   331,    -1,    -1,   334,    -1,    -1,     1,
     338,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,   277,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334,    -1,    -1,     1,   338,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,   277,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,
      -1,    -1,   334,    -1,    -1,     1,   338,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,   277,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,    -1,
      -1,   334,    -1,    -1,    -1,   338,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,
     334,    -1,    -1,    -1,   338,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,   331,
      -1,    -1,   334,    -1,    -1,     1,   338,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,   277,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,
      -1,     1,   338,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,   277,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,
      -1,     1,   338,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,   277,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,   330,
     331,    -1,    -1,   334,    -1,    -1,    -1,   338,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334,    -1,    -1,    -1,   338,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,
     330,   331,    -1,    -1,   334,    -1,    -1,     1,   338,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,    -1,    -1,   335,   336,   337,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,   335,   336,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,   335,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   311,    -1,    -1,   314,    -1,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
     337,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,
      -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
      -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,   337,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,
      -1,    -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,   337,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,
      -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
      -1,    -1,    -1,   336,   337,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,
      -1,    -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,   337,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,    -1,   330,
     331,    -1,    -1,    -1,    -1,   336,   337,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,
      -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,    -1,   330,   331,    -1,
      -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
      -1,   330,   331,    -1,    -1,    -1,    -1,   336,   337,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,
      -1,    -1,    -1,    -1,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,
      -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,    -1,
     337,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
      -1,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,   337,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,   277,   278,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   311,    -1,    -1,    -1,    -1,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,    -1,
     330,   331,    -1,    -1,    -1,    -1,   336,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,
      -1,    -1,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,   330,   331,    -1,    -1,   334,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,   330,   331,    -1,    -1,   334
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   262,   263,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   289,   290,   291,   326,   334,
     341,   344,   345,   346,   347,   348,   349,   350,   351,   362,
     366,   369,   370,   372,   373,   383,   384,   393,   292,     1,
     339,     1,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,     1,   292,     1,   292,     1,
     292,     1,   292,     1,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,     1,   328,     1,
     292,   328,     1,   336,     1,   292,   328,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,     1,
     292,     1,   292,     1,   292,     1,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   292,   292,   292,   292,
     292,   292,   292,     1,   292,   292,   292,   292,   292,   292,
     292,   292,   292,   292,   292,   292,   322,   292,   292,   292,
     292,   292,   292,   292,   292,     1,   326,   328,   363,   364,
     365,     1,   365,   367,   368,     1,   328,     1,   328,     1,
     328,     0,     1,   346,    14,    15,   379,   380,    16,   381,
     382,    19,   387,   388,    20,   389,   390,    21,   391,   392,
     322,   339,   337,   325,   326,   328,   378,     1,   325,     1,
     325,     1,    88,    89,    90,    91,   315,   355,     1,   311,
     325,   361,     1,   325,     1,   325,     1,   361,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   326,     1,   328,
       1,   325,     1,   328,     1,   325,     1,   328,     1,   328,
       1,   328,     1,   328,     1,   325,   326,   327,   328,   329,
     336,   339,   352,   354,   355,   359,   360,   374,   375,   376,
     377,   407,   408,     1,   360,     1,   325,     1,   325,     1,
     325,   325,   325,   325,   361,   361,   361,   361,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,     1,   361,     1,   325,   328,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   361,     1,   361,     1,   361,
       1,   361,     1,   361,     1,   361,     1,   361,     1,   325,
       1,   325,     1,   328,     1,   328,     1,   325,     1,   328,
     328,     1,   328,     1,   325,     1,   325,     1,   326,   328,
       1,   326,   328,     1,   326,   328,     1,   326,   328,     1,
     326,   328,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   361,     1,   361,     1,   361,     1,   326,   328,     1,
     325,     1,   325,     1,   325,     1,   325,   375,     1,   377,
       1,   325,     1,   325,   325,   325,   325,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   325,     1,   220,   221,   222,   223,     1,   325,     1,
     325,     1,   325,     1,   325,     1,   328,     1,   328,     1,
     328,     1,   325,     1,   325,     1,   325,     1,   352,     1,
     325,     1,   325,     1,   325,     1,   325,     1,   325,     1,
     325,     1,   325,     1,   325,     1,   325,     1,   325,     1,
     325,     1,   325,     1,   325,     1,   325,     1,   325,     1,
     326,   328,     1,   325,   326,   325,     1,   325,     1,   325,
       1,   325,     1,   325,     1,   325,     1,   325,     1,   325,
       1,   328,     1,   325,     1,   325,     1,   325,   264,   265,
     266,   325,   325,     1,   361,     1,   361,     1,   325,     1,
     325,     1,   325,     1,   325,   333,   342,   333,     1,   339,
       1,   337,     1,   339,   337,     1,   339,   337,     1,   339,
     337,     1,   339,    57,   325,   326,   371,   325,   385,   340,
     325,   322,   352,   353,   376,   342,   342,   360,   109,   311,
     322,   333,   292,   292,   292,   363,   325,   367,   378,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    22,    23,    24,    25,    26,    27,    28,    29,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    42,
      46,    48,    49,    50,    51,    52,    53,    54,    55,    58,
      59,    60,    64,    65,    66,    67,    68,    69,   277,   326,
     330,   331,   334,   409,   411,   412,   413,   417,   418,   426,
     427,   429,   430,   433,   434,   436,   440,   441,   442,   446,
     378,   411,   378,   411,   378,   411,   332,   292,   340,   411,
       1,   386,   325,   333,   335,   340,     1,   315,   325,   357,
     354,   352,     1,   325,   407,     1,   407,   328,     1,   328,
       1,   328,     1,   328,   340,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,   278,   311,   316,   318,   319,   320,   321,
     323,   324,   328,   336,   337,   361,   399,   400,   401,   402,
     403,   404,   409,   421,   426,   427,   428,   429,   431,   433,
     434,   437,   438,   439,   336,   439,   336,   439,     1,   336,
       1,   336,     1,   336,   336,     1,   336,     1,   336,     1,
     336,     1,   336,     1,   336,     1,   336,     1,   336,     1,
     336,   336,     1,   336,     1,   336,     1,   336,     1,   336,
     336,   336,   336,   336,   336,   336,   439,     1,   336,     1,
     336,     1,   336,   336,   336,   336,   336,     1,   439,   439,
       1,   336,     1,   336,     1,   336,     1,   336,     1,   336,
       1,   443,     1,   334,     1,   338,   412,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   326,   423,   424,   425,
     292,   435,   334,     1,   336,   334,   340,   338,   340,   338,
     340,   338,   340,     1,   325,   328,   322,   338,   337,   322,
     353,   342,   342,   333,   337,     1,    61,   326,   328,   335,
     374,   406,     1,    61,   328,   374,   406,     1,    61,   328,
     374,   406,     1,    61,   328,   374,   406,     1,    61,   328,
     374,   406,     1,   300,   301,   304,   305,   306,   394,   396,
     394,   394,     1,   394,   422,     1,   439,     1,   439,     1,
     439,   336,   336,     1,   335,   427,   429,   433,   434,   439,
     440,     1,   411,     1,   396,     1,   307,   308,   309,   310,
     394,   395,     1,   396,   425,     1,   439,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     397,   398,   335,   335,     1,   325,   328,     1,   328,     1,
     326,   439,   328,     1,   328,     1,   328,     1,   328,     1,
     328,     1,   325,     1,   325,   335,     1,   335,   361,   335,
       1,   328,     1,   328,     1,   328,     1,   328,   335,   335,
     335,     1,   325,   335,     1,   355,   337,   410,   412,     1,
     352,     1,   325,     1,   352,   355,   358,   335,   335,   335,
     335,   337,   410,     1,   328,     1,   328,   325,   365,   325,
     365,   325,   365,   336,   322,   339,   439,     1,   328,   426,
     427,   432,   434,   337,   337,   337,   337,   261,   261,   371,
     411,   325,   357,   325,   328,   361,   411,   335,   333,   335,
     333,   335,   333,   335,   311,   322,   333,   335,   335,   333,
     335,   333,   335,   333,   335,   333,   335,   335,   333,   335,
     333,   335,   333,   335,   333,   335,   335,   333,   335,   333,
     335,   333,   335,   333,   335,   335,   333,   335,   333,   335,
     333,   335,   333,   335,     1,   326,   439,     1,    88,    89,
      90,    91,    92,    93,   315,   356,   439,     1,   356,   439,
       1,   399,   403,   326,   419,   420,     1,   439,     1,   439,
     335,   335,   335,   338,   338,     1,    86,   439,     1,   439,
       1,   439,     1,    86,   325,   326,   374,   405,   406,   439,
     339,     1,   439,     1,   439,     1,   439,     1,   439,   439,
     439,   439,     1,   439,     1,   439,     1,   439,     1,   439,
       1,   439,     1,   439,     1,   439,   335,   333,   335,   335,
     333,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   411,    47,   335,   335,   335,   335,   335,   342,   342,
     335,     1,    56,    57,   338,   415,   416,   335,   333,   335,
     335,   335,   335,   335,   335,   335,   335,   439,   444,   445,
     424,   340,   333,   335,   425,   333,   411,   411,   411,   411,
     328,   328,   292,   338,   322,   335,   335,   338,    62,   325,
     325,   325,     1,   326,     1,   326,   325,    62,   325,   325,
     325,   325,    62,   325,   325,   325,   325,    62,   325,   325,
     325,   325,    62,   325,   325,   325,   325,   339,   322,   335,
     335,   335,   335,   314,   361,   328,   328,   338,   410,     1,
     357,   352,   338,     1,   314,   414,   439,   342,   338,   415,
     325,   439,   333,   335,   365,     1,   365,   338,   338,   338,
     338,   325,   328,   325,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   328,
     361,   419,     1,   325,   374,   340,   335,   335,   342,   342,
       1,   414,   342,   411,   335,   335,   445,   335,   335,   335,
     340,   340,   357,   411,   342,   342,     1,   411,   411,   411
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 622 "core/cfg.y"
    {;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 623 "core/cfg.y"
    {;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 624 "core/cfg.y"
    { yyerror(""); YYABORT;;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 632 "core/cfg.y"
    {rt=REQUEST_ROUTE;;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 633 "core/cfg.y"
    {rt=FAILURE_ROUTE;;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 635 "core/cfg.y"
    {rt=BRANCH_ROUTE;;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 636 "core/cfg.y"
    {rt=ONSEND_ROUTE;;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 637 "core/cfg.y"
    {rt=EVENT_ROUTE;;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 642 "core/cfg.y"
    {
		if ((yyvsp[(1) - (1)].ipaddr)){
			tmp=ip_addr2a((yyvsp[(1) - (1)].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					LM_CRIT("cfg. parser: out of memory.\n");
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 658 "core/cfg.y"
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[(1) - (1)].strval))+1);
		if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: out of memory.\n");
		} else {
				strncpy((yyval.strval), (yyvsp[(1) - (1)].strval), strlen((yyvsp[(1) - (1)].strval))+1);
		}
	;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 666 "core/cfg.y"
    {
		if ((yyvsp[(1) - (1)].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[(1) - (1)].strval))+1);
			if ((yyval.strval)==0) {
					LM_CRIT("cfg. parser: out of memory.\n");
			} else {
					strncpy((yyval.strval), (yyvsp[(1) - (1)].strval), strlen((yyvsp[(1) - (1)].strval))+1);
			}
		}
	;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 680 "core/cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (1)].strval), SI_IS_MHOMED); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 681 "core/cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (3)].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[(3) - (3)].name_l);
									;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 687 "core/cfg.y"
    { (yyval.name_l)=(yyvsp[(2) - (3)].name_l); ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 688 "core/cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (1)].strval), 0); ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 692 "core/cfg.y"
    { (yyval.intval)=PROTO_UDP; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 693 "core/cfg.y"
    { (yyval.intval)=PROTO_TCP; ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 694 "core/cfg.y"
    { (yyval.intval)=PROTO_TLS; ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 695 "core/cfg.y"
    { (yyval.intval)=PROTO_SCTP; ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 696 "core/cfg.y"
    { (yyval.intval)=0; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 699 "core/cfg.y"
    { (yyval.intval)=PROTO_UDP; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 700 "core/cfg.y"
    { (yyval.intval)=PROTO_TCP; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 701 "core/cfg.y"
    { (yyval.intval)=PROTO_TLS; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 702 "core/cfg.y"
    { (yyval.intval)=PROTO_SCTP; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 703 "core/cfg.y"
    { (yyval.intval)=PROTO_WS; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 704 "core/cfg.y"
    { (yyval.intval)=PROTO_WSS; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 705 "core/cfg.y"
    { (yyval.intval)=0; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 708 "core/cfg.y"
    { (yyval.intval)=(yyvsp[(1) - (1)].intval); ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 709 "core/cfg.y"
    { (yyval.intval)=0; ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 712 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(1) - (1)].strval), 0, 0); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 713 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(1) - (3)].strval), 0, (yyvsp[(3) - (3)].intval)); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 714 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(3) - (3)].strval), (yyvsp[(1) - (3)].intval), 0); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 715 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(3) - (5)].strval), (yyvsp[(1) - (5)].intval), (yyvsp[(5) - (5)].intval));;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 716 "core/cfg.y"
    { (yyval.sockid)=0; yyerror("port number expected"); ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 720 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(1) - (1)].name_l), 0, 0); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 721 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(1) - (3)].name_l), 0, (yyvsp[(3) - (3)].intval)); ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 722 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(3) - (3)].name_l), (yyvsp[(1) - (3)].intval), 0); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 723 "core/cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(3) - (5)].name_l), (yyvsp[(1) - (5)].intval), (yyvsp[(5) - (5)].intval));;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 724 "core/cfg.y"
    { (yyval.sockid)=0; yyerror("port number expected"); ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 728 "core/cfg.y"
    {  (yyval.sockid)=(yyvsp[(1) - (1)].sockid) ; ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 729 "core/cfg.y"
    { (yyval.sockid)=(yyvsp[(1) - (2)].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[(2) - (2)].sockid); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 733 "core/cfg.y"
    { (yyval.intval)=-(yyvsp[(2) - (2)].intval); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 737 "core/cfg.y"
    { yyerror("flag list expected\n"); ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 743 "core/cfg.y"
    { if (register_flag((yyvsp[(1) - (1)].strval),-1)<0)
								yyerror("register flag failed");
						;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 746 "core/cfg.y"
    {
						if (register_flag((yyvsp[(1) - (3)].strval), (yyvsp[(3) - (3)].intval))<0)
								yyerror("register flag failed");
										;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 752 "core/cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 753 "core/cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 758 "core/cfg.y"
    { yyerror("avpflag list expected\n"); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 765 "core/cfg.y"
    {
		if (register_avpflag((yyvsp[(1) - (1)].strval))==0)
			yyerror("cannot declare avpflag");
	;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 771 "core/cfg.y"
    { default_core_cfg.debug=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 772 "core/cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 773 "core/cfg.y"
    { dont_fork= ! (yyvsp[(3) - (3)].intval); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 774 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 775 "core/cfg.y"
    { set_fork_delay((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 776 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 777 "core/cfg.y"
    { set_modinit_delay((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 778 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 779 "core/cfg.y"
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[(3) - (3)].intval);
				   ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 782 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 783 "core/cfg.y"
    {
		if ( (i_tmp=str2facility((yyvsp[(3) - (3)].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 789 "core/cfg.y"
    { yyerror("ID expected"); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 790 "core/cfg.y"
    { log_name=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 791 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 792 "core/cfg.y"
    { log_color=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 793 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 794 "core/cfg.y"
    { log_prefix_fmt=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 795 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 796 "core/cfg.y"
    { log_prefix_mode=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 797 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 798 "core/cfg.y"
    { _km_log_engine_type=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 799 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 800 "core/cfg.y"
    { _km_log_engine_data=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 801 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 802 "core/cfg.y"
    { _ksr_xavp_via_params.s=(yyvsp[(3) - (3)].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[(3) - (3)].strval));
		;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 805 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 806 "core/cfg.y"
    { _ksr_xavp_via_params.s=(yyvsp[(3) - (3)].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[(3) - (3)].strval));
		;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 809 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 810 "core/cfg.y"
    { received_dns|= ((yyvsp[(3) - (3)].intval))?DO_DNS:0; ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 811 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 812 "core/cfg.y"
    { received_dns|= ((yyvsp[(3) - (3)].intval))?DO_REV_DNS:0; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 813 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 814 "core/cfg.y"
    { default_core_cfg.dns_try_ipv6=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 815 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 816 "core/cfg.y"
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 817 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 818 "core/cfg.y"
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 819 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 820 "core/cfg.y"
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[(3) - (3)].intval));;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 821 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 822 "core/cfg.y"
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[(3) - (3)].intval));;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 823 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 824 "core/cfg.y"
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[(3) - (3)].intval));;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 825 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 826 "core/cfg.y"
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 828 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 829 "core/cfg.y"
    { default_core_cfg.dns_retr_time=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 830 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 831 "core/cfg.y"
    { default_core_cfg.dns_retr_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 832 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 833 "core/cfg.y"
    { default_core_cfg.dns_servers_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 834 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 835 "core/cfg.y"
    { default_core_cfg.dns_search_list=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 836 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 837 "core/cfg.y"
    { default_core_cfg.dns_search_fmatch=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 838 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 839 "core/cfg.y"
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 840 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 841 "core/cfg.y"
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 842 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 843 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 844 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 845 "core/cfg.y"
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[(3) - (3)].intval));;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 846 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 847 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 848 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 849 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 850 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 851 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 852 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 853 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 854 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 855 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 856 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 857 "core/cfg.y"
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 858 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 859 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 860 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 861 "core/cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 862 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 863 "core/cfg.y"
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[(3) - (3)].intval));;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 864 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 865 "core/cfg.y"
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 866 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 867 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 870 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 871 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 874 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 875 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 878 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 879 "core/cfg.y"
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[(3) - (3)].intval));;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 880 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 881 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 884 "core/cfg.y"
    { yyerror("number(flags) expected"); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 885 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 888 "core/cfg.y"
    { yyerror("number(flags) expected"); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 889 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 892 "core/cfg.y"
    { yyerror("number(flags) expected"); ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 893 "core/cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 896 "core/cfg.y"
    { yyerror("number(flags) expected"); ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 897 "core/cfg.y"
    { _sr_ip_free_bind=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 898 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 899 "core/cfg.y"
    { port_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 900 "core/cfg.y"
    {
		#ifdef STATS
				stat_file=(yyvsp[(3) - (3)].strval);
		#endif
	;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 905 "core/cfg.y"
    { maxbuffer=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 906 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 907 "core/cfg.y"
    { sql_buffer_size=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 908 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 909 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 910 "core/cfg.y"
    { children_no=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 911 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 912 "core/cfg.y"
    { socket_workers=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 913 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 914 "core/cfg.y"
    { async_task_set_workers((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 915 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 916 "core/cfg.y"
    { async_task_set_usleep((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 917 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 918 "core/cfg.y"
    { async_task_set_nonblock((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 919 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 920 "core/cfg.y"
    { check_via=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 921 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 922 "core/cfg.y"
    { phone2tel=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 923 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 924 "core/cfg.y"
    { default_core_cfg.memlog=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 925 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 926 "core/cfg.y"
    { default_core_cfg.memdbg=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 927 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 928 "core/cfg.y"
    { default_core_cfg.mem_summary=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 929 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 930 "core/cfg.y"
    { default_core_cfg.mem_safety=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 931 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 932 "core/cfg.y"
    { default_core_cfg.mem_join=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 933 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 934 "core/cfg.y"
    { default_core_cfg.mem_status_mode=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 935 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 936 "core/cfg.y"
    { default_core_cfg.corelog=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 937 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 938 "core/cfg.y"
    { sip_warning=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 939 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 940 "core/cfg.y"
    { version_table.s=(yyvsp[(3) - (3)].strval);
			version_table.len=strlen(version_table.s);
	;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 943 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 944 "core/cfg.y"
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[(3) - (3)].strval);
	;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 951 "core/cfg.y"
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[(3) - (3)].strval);
	;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 958 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 959 "core/cfg.y"
    { group=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 960 "core/cfg.y"
    { group=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 961 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 962 "core/cfg.y"
    { chroot_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 963 "core/cfg.y"
    { chroot_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 964 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 965 "core/cfg.y"
    { working_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 966 "core/cfg.y"
    { working_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 967 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 968 "core/cfg.y"
    { runtime_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 969 "core/cfg.y"
    { runtime_dir=(yyvsp[(3) - (3)].strval); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 970 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 971 "core/cfg.y"
    { mhomed=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 972 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 973 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 980 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 981 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 988 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 989 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 996 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 997 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1004 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1005 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1012 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1013 "core/cfg.y"
    {
		#ifdef USE_TCP
			if ((yyvsp[(3) - (3)].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1023 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1024 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[(3) - (3)].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[(3) - (3)].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1038 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[(3) - (3)].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[(3) - (3)].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1052 "core/cfg.y"
    { yyerror("poll method name expected"); ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1053 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1060 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1061 "core/cfg.y"
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1068 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1069 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1076 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1077 "core/cfg.y"
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[(3) - (3)].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[(3) - (3)].ipaddr));
	;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1086 "core/cfg.y"
    { yyerror("IPv4 address expected"); ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1087 "core/cfg.y"
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[(3) - (3)].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[(3) - (3)].ipaddr));
	;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1096 "core/cfg.y"
    { yyerror("IPv6 address expected"); ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1097 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1104 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1105 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1112 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1113 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1120 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1121 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1128 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1129 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1136 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1137 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1144 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1145 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1152 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1153 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1160 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1161 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1168 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1169 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1176 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1177 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1184 "core/cfg.y"
    { yyerror("boolean value expected");;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1185 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1192 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1193 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1200 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1201 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1208 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1209 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1216 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1217 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1224 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1225 "core/cfg.y"
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1232 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1234 "core/cfg.y"
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1241 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1242 "core/cfg.y"
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[(3) - (3)].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1253 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1254 "core/cfg.y"
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1261 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1262 "core/cfg.y"
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[(3) - (3)].intval));
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1269 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1270 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1277 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1278 "core/cfg.y"
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1285 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1286 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1293 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1300 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1307 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1314 "core/cfg.y"
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1321 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1328 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1329 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[(3) - (3)].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1336 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1337 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1344 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1345 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1352 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1353 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1360 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1361 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 1368 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1369 "core/cfg.y"
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1376 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1377 "core/cfg.y"
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1384 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1385 "core/cfg.y"
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[(3) - (3)].intval)<=1)?!(yyvsp[(3) - (3)].intval):(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1392 "core/cfg.y"
    { yyerror("boolean or number expected"); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1393 "core/cfg.y"
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1400 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1401 "core/cfg.y"
    { server_signature=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1402 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1403 "core/cfg.y"
    { server_hdr.s=(yyvsp[(3) - (3)].strval);
			server_hdr.len=strlen(server_hdr.s);
	;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1406 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1407 "core/cfg.y"
    { user_agent_hdr.s=(yyvsp[(3) - (3)].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1410 "core/cfg.y"
    { yyerror("string value expected"); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1411 "core/cfg.y"
    { reply_to_via=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1412 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1413 "core/cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (3)].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[(3) - (3)].sockid));
	;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1425 "core/cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (7)].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[(5) - (7)].strval), (yyvsp[(7) - (7)].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[(3) - (7)].sockid));
	;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1438 "core/cfg.y"
    { yyerror("ip address, interface name or"
									" hostname expected"); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1440 "core/cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (3)].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[(3) - (3)].sockid));
	;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1451 "core/cfg.y"
    { yyerror("hostname expected"); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1452 "core/cfg.y"
    { sr_auto_aliases=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1453 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1454 "core/cfg.y"
    {
		if ((yyvsp[(3) - (3)].strval)){
			default_global_address.s=(yyvsp[(3) - (3)].strval);
			default_global_address.len=strlen((yyvsp[(3) - (3)].strval));
		}
	;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1460 "core/cfg.y"
    {yyerror("ip address or hostname expected"); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1461 "core/cfg.y"
    {
		tmp=int2str((yyvsp[(3) - (3)].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1471 "core/cfg.y"
    {yyerror("ip address or hostname expected"); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1472 "core/cfg.y"
    { disable_core_dump=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1473 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1474 "core/cfg.y"
    { open_files_limit=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1475 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1476 "core/cfg.y"
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[(3) - (3)].intval) * 1024 * 1024;
	;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1483 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1484 "core/cfg.y"
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[(3) - (3)].intval);
	;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1491 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1492 "core/cfg.y"
    { mlock_pages=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1493 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1494 "core/cfg.y"
    { real_time=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1495 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1496 "core/cfg.y"
    { rt_prio=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1497 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1498 "core/cfg.y"
    { rt_policy=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1499 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 1500 "core/cfg.y"
    { rt_timer1_prio=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1501 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1502 "core/cfg.y"
    { rt_timer1_policy=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1503 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 1504 "core/cfg.y"
    { rt_timer2_prio=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 1505 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1506 "core/cfg.y"
    { rt_timer2_policy=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1507 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 1508 "core/cfg.y"
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[(3) - (3)].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1515 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1516 "core/cfg.y"
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[(3) - (3)].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 1523 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1524 "core/cfg.y"
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[(3) - (3)].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1531 "core/cfg.y"
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[(3) - (3)].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1538 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1539 "core/cfg.y"
    { tos=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1540 "core/cfg.y"
    { if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1567 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1568 "core/cfg.y"
    { pmtu_discovery=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1569 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1570 "core/cfg.y"
    { ser_kill_timeout=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1571 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1572 "core/cfg.y"
    { default_core_cfg.max_while_loops=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1573 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1574 "core/cfg.y"
    { pv_set_buffer_size((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1575 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1576 "core/cfg.y"
    { pv_set_buffer_slots((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1577 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1578 "core/cfg.y"
    { default_core_cfg.pv_cache_limit=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1579 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1580 "core/cfg.y"
    { default_core_cfg.pv_cache_action=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1581 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1582 "core/cfg.y"
    { http_reply_parse=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1583 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1584 "core/cfg.y"
    { ksr_verbose_startup=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1585 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1586 "core/cfg.y"
    { ksr_route_locks_size=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1587 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1588 "core/cfg.y"
    { server_id=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1589 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1590 "core/cfg.y"
    {
			kemi_onsend_route_callback.s = (yyvsp[(5) - (5)].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[(5) - (5)].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1599 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1600 "core/cfg.y"
    {
			kemi_reply_route_callback.s = (yyvsp[(5) - (5)].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[(5) - (5)].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1609 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 1610 "core/cfg.y"
    {
			kemi_event_route_callback.s = (yyvsp[(5) - (5)].strval);
			kemi_event_route_callback.len = strlen((yyvsp[(5) - (5)].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 1619 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 1620 "core/cfg.y"
    { set_max_recursive_level((yyvsp[(3) - (3)].intval)); ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 1621 "core/cfg.y"
    { sr_dst_max_branches = (yyvsp[(3) - (3)].intval); ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 1622 "core/cfg.y"
    { default_core_cfg.latency_log=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 1623 "core/cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 1624 "core/cfg.y"
    { default_core_cfg.latency_cfg_log=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 1625 "core/cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 1626 "core/cfg.y"
    { default_core_cfg.latency_limit_db=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 1627 "core/cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 1628 "core/cfg.y"
    { default_core_cfg.latency_limit_action=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 1629 "core/cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 1630 "core/cfg.y"
    { sr_msg_time=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 1631 "core/cfg.y"
    { yyerror("number  expected"); ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 1632 "core/cfg.y"
    { onsend_route_reply=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 1633 "core/cfg.y"
    { yyerror("int value expected"); ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 1634 "core/cfg.y"
    { default_core_cfg.udp_mtu=(yyvsp[(3) - (3)].intval); ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 1635 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1637 "core/cfg.y"
    { default_core_cfg.force_rport=(yyvsp[(3) - (3)].intval); fix_global_req_flags(0, 0); ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 1638 "core/cfg.y"
    { yyerror("boolean value expected"); ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 1640 "core/cfg.y"
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[(3) - (3)].intval); fix_global_req_flags(0, 0); ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 1642 "core/cfg.y"
    { yyerror("TCP, TLS, SCTP or UDP expected"); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 1643 "core/cfg.y"
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[(3) - (3)].intval)); ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 1644 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 1645 "core/cfg.y"
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1648 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 1649 "core/cfg.y"
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[(3) - (3)].intval));
	;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 1652 "core/cfg.y"
    { yyerror("number expected"); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 1654 "core/cfg.y"
    { yyerror("unknown config variable"); ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1658 "core/cfg.y"
    { (yyval.strval)="default" ; ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 1662 "core/cfg.y"
    { (yyval.strval)="default" ; ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 1663 "core/cfg.y"
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 1671 "core/cfg.y"
    {
		if (cfg_declare_int((yyvsp[(1) - (5)].strval), (yyvsp[(3) - (5)].strval), (yyvsp[(5) - (5)].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 1676 "core/cfg.y"
    {
		if (cfg_declare_str((yyvsp[(1) - (5)].strval), (yyvsp[(3) - (5)].strval), (yyvsp[(5) - (5)].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 1681 "core/cfg.y"
    {
		if (cfg_declare_int((yyvsp[(1) - (7)].strval), (yyvsp[(3) - (7)].strval), (yyvsp[(5) - (7)].intval), 0, 0, (yyvsp[(7) - (7)].strval))) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1686 "core/cfg.y"
    {
		if (cfg_declare_str((yyvsp[(1) - (7)].strval), (yyvsp[(3) - (7)].strval), (yyvsp[(5) - (7)].strval), (yyvsp[(7) - (7)].strval))) {
			yyerror("variable cannot be declared");
		}
	;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 1691 "core/cfg.y"
    {
		yyerror("number or string expected");
	;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1694 "core/cfg.y"
    {
		if (cfg_ginst_var_int((yyvsp[(1) - (8)].strval), (yyvsp[(3) - (8)].intval), (yyvsp[(6) - (8)].strval), (yyvsp[(8) - (8)].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1699 "core/cfg.y"
    {
		if (cfg_ginst_var_string((yyvsp[(1) - (8)].strval), (yyvsp[(3) - (8)].intval), (yyvsp[(6) - (8)].strval), (yyvsp[(8) - (8)].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 1707 "core/cfg.y"
    {
		LM_DBG("loading module %s\n", (yyvsp[(2) - (2)].strval));
			if (load_module((yyvsp[(2) - (2)].strval))!=0) {
				yyerror("failed to load module");
			}
	;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 1713 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1714 "core/cfg.y"
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[(2) - (2)].strval));
			printf("loading modules under config path: %s\n", (yyvsp[(2) - (2)].strval));
			mods_dir = (yyvsp[(2) - (2)].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[(2) - (2)].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 1724 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 1725 "core/cfg.y"
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[(3) - (3)].strval));
			printf("loading modules under config path: %s\n", (yyvsp[(3) - (3)].strval));
			mods_dir = (yyvsp[(3) - (3)].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[(3) - (3)].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1735 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 1736 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[(3) - (8)].strval), (yyvsp[(5) - (8)].strval), PARAM_STRING, (yyvsp[(7) - (8)].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 1747 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[(3) - (8)].strval), (yyvsp[(5) - (8)].strval), PARAM_INT, (void*)(yyvsp[(7) - (8)].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 1758 "core/cfg.y"
    { yyerror("Invalid arguments"); ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 1759 "core/cfg.y"
    {
		if(sr_kemi_eng_setz((yyvsp[(2) - (2)].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 1765 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1766 "core/cfg.y"
    {
		if(sr_kemi_eng_setz((yyvsp[(3) - (3)].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 1772 "core/cfg.y"
    { yyerror("string expected"); ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 1776 "core/cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 1777 "core/cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 1780 "core/cfg.y"
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[(1) - (7)].intval)>255) || ((yyvsp[(1) - (7)].intval)<0) ||
				((yyvsp[(3) - (7)].intval)>255) || ((yyvsp[(3) - (7)].intval)<0) ||
				((yyvsp[(5) - (7)].intval)>255) || ((yyvsp[(5) - (7)].intval)<0) ||
				((yyvsp[(7) - (7)].intval)>255) || ((yyvsp[(7) - (7)].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[(1) - (7)].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[(3) - (7)].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[(5) - (7)].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[(7) - (7)].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 1809 "core/cfg.y"
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[(1) - (1)].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 1824 "core/cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 1825 "core/cfg.y"
    {(yyval.ipaddr)=(yyvsp[(2) - (3)].ipaddr); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 1829 "core/cfg.y"
    {
					tmp=int2str((yyvsp[(1) - (1)].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 1840 "core/cfg.y"
    { routename = (yyvsp[(1) - (1)].strval); (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 1841 "core/cfg.y"
    { routename = (yyvsp[(1) - (1)].strval); (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 1845 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 1846 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 1850 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &main_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 1859 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&main_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &main_rt.rlist[i_tmp]);
	;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 1877 "core/cfg.y"
    { yyerror("invalid  route  statement"); ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 1878 "core/cfg.y"
    { yyerror("invalid  request_route  statement"); ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 1881 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 1884 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &failure_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 1893 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&failure_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &failure_rt.rlist[i_tmp]);
	;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 1911 "core/cfg.y"
    { yyerror("invalid failure_route statement"); ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 1915 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 1916 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 1921 "core/cfg.y"
    {rt=CORE_ONREPLY_ROUTE;;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 1921 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(4) - (5)].action), &onreply_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 1930 "core/cfg.y"
    { yyerror("invalid onreply_route statement"); ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 1931 "core/cfg.y"
    { yyerror("invalid onreply_route statement"); ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 1933 "core/cfg.y"
    {rt=(*(yyvsp[(3) - (4)].strval)=='0' && (yyvsp[(3) - (4)].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 1934 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (*(yyvsp[(3) - (8)].strval)=='0' && (yyvsp[(3) - (8)].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[(7) - (8)].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[(3) - (8)].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[(7) - (8)].action), &onreply_rt.rlist[i_tmp]);
		}
	;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 1957 "core/cfg.y"
    {
		yyerror("invalid onreply_route statement");
	;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 1962 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 1965 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &branch_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 1974 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&branch_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &branch_rt.rlist[i_tmp]);
	;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 1992 "core/cfg.y"
    { yyerror("invalid branch_route statement"); ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 1995 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 1998 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &onsend_rt.rlist[DEFAULT_RT]);
	;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 2007 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&onsend_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &onsend_rt.rlist[i_tmp]);
	;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 2025 "core/cfg.y"
    { yyerror("invalid onsend_route statement"); ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 2028 "core/cfg.y"
    { routename=NULL; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 2031 "core/cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&event_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &event_rt.rlist[i_tmp]);
	;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 2050 "core/cfg.y"
    { yyerror("invalid event_route statement"); ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 2053 "core/cfg.y"
    { if(pp_subst_add((yyvsp[(2) - (2)].strval))<0) YYERROR; ;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 2054 "core/cfg.y"
    { yyerror("invalid subst preprocess statement"); ;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 2055 "core/cfg.y"
    { if(pp_substdef_add((yyvsp[(2) - (2)].strval), 0)<0) YYERROR; ;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 2056 "core/cfg.y"
    { yyerror("invalid substdef preprocess statement"); ;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 2057 "core/cfg.y"
    { if(pp_substdef_add((yyvsp[(2) - (2)].strval), 1)<0) YYERROR; ;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 2058 "core/cfg.y"
    { yyerror("invalid substdefs preprocess statement"); ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 2080 "core/cfg.y"
    {(yyval.intval)=EQUAL_OP; ;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 2081 "core/cfg.y"
    {(yyval.intval)=DIFF_OP; ;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 2082 "core/cfg.y"
    {(yyval.intval)=EQUAL_OP; ;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 2083 "core/cfg.y"
    {(yyval.intval)=DIFF_OP; ;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 2086 "core/cfg.y"
    {(yyval.intval)=GT_OP; ;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 2087 "core/cfg.y"
    {(yyval.intval)=LT_OP; ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 2088 "core/cfg.y"
    {(yyval.intval)=GTE_OP; ;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 2089 "core/cfg.y"
    {(yyval.intval)=LTE_OP; ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 2092 "core/cfg.y"
    {(yyval.intval)=(yyvsp[(1) - (1)].intval); ;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 2093 "core/cfg.y"
    {(yyval.intval)=MATCH_OP; ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 2099 "core/cfg.y"
    {(yyval.intval)=RVE_EQ_OP; ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 2100 "core/cfg.y"
    {(yyval.intval)=RVE_DIFF_OP; ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 2101 "core/cfg.y"
    {(yyval.intval)=RVE_IEQ_OP; ;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 2102 "core/cfg.y"
    {(yyval.intval)=RVE_IDIFF_OP; ;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 2103 "core/cfg.y"
    {(yyval.intval)=RVE_STREQ_OP; ;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 2104 "core/cfg.y"
    {(yyval.intval)=RVE_STRDIFF_OP; ;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 2105 "core/cfg.y"
    {(yyval.intval)=RVE_MATCH_OP; ;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 2108 "core/cfg.y"
    {(yyval.intval)=RVE_GT_OP; ;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 2109 "core/cfg.y"
    {(yyval.intval)=RVE_LT_OP; ;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 2110 "core/cfg.y"
    {(yyval.intval)=RVE_GTE_OP; ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 2111 "core/cfg.y"
    {(yyval.intval)=RVE_LTE_OP; ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 2118 "core/cfg.y"
    {(yyval.intval)=URI_O;;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 2119 "core/cfg.y"
    {(yyval.intval)=FROM_URI_O;;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 2120 "core/cfg.y"
    {(yyval.intval)=TO_URI_O;;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 2127 "core/cfg.y"
    { (yyval.intval)=SNDPORT_O; ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 2128 "core/cfg.y"
    { (yyval.intval)=TOPORT_O; ;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 2129 "core/cfg.y"
    { (yyval.intval)=SNDAF_O; ;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 2133 "core/cfg.y"
    { (yyval.intval)=SRCPORT_O; ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 2134 "core/cfg.y"
    { (yyval.intval)=DSTPORT_O; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 2135 "core/cfg.y"
    { (yyval.intval)=AF_O; ;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 2136 "core/cfg.y"
    { (yyval.intval)=MSGLEN_O; ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 2142 "core/cfg.y"
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 2143 "core/cfg.y"
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 2146 "core/cfg.y"
    { (yyval.intval)=SRCIP_O; ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 2147 "core/cfg.y"
    { (yyval.intval)=DSTIP_O; ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 2155 "core/cfg.y"
    {(yyval.expr)= mk_elem((yyvsp[(2) - (3)].intval), METHOD_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 2157 "core/cfg.y"
    {(yyval.expr) = mk_elem((yyvsp[(2) - (3)].intval), METHOD_O, 0, STRING_ST,(yyvsp[(3) - (3)].strval)); ;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 2158 "core/cfg.y"
    { (yyval.expr)=0; yyerror("string expected"); ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 2160 "core/cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 2162 "core/cfg.y"
    {(yyval.expr) = mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 2164 "core/cfg.y"
    {(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 2166 "core/cfg.y"
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 2168 "core/cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 2169 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 2171 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 2172 "core/cfg.y"
    { (yyval.expr)=0; yyerror("number expected"); ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 2173 "core/cfg.y"
    { (yyval.expr)=0; yyerror("number expected"); ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 2174 "core/cfg.y"
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 2176 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[(3) - (3)].intval) ); ;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 2178 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), PROTO_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 2180 "core/cfg.y"
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 2182 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[(3) - (3)].intval) ); ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 2184 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 2186 "core/cfg.y"
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 2187 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, NET_ST, (yyvsp[(3) - (3)].ipnet)); ;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 2188 "core/cfg.y"
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[(3) - (3)].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[(3) - (3)].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[(3) - (3)].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));
			}
		;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 2225 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, STRING_ST, (yyvsp[(3) - (3)].strval)); ;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 2227 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 2229 "core/cfg.y"
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); ;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 2231 "core/cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 2234 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 2236 "core/cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), 0, MYSELF_ST, 0); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 2238 "core/cfg.y"
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 2239 "core/cfg.y"
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); ;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 2243 "core/cfg.y"
    { (yyval.ipnet)=mk_new_net((yyvsp[(1) - (3)].ipaddr), (yyvsp[(3) - (3)].ipaddr)); ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 2244 "core/cfg.y"
    {
		if (((yyvsp[(3) - (3)].intval)<0) || ((yyvsp[(3) - (3)].intval)>(yyvsp[(1) - (3)].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[(1) - (3)].ipaddr), (yyvsp[(3) - (3)].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 2255 "core/cfg.y"
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[(1) - (1)].ipaddr), (yyvsp[(1) - (1)].ipaddr)->len*8); ;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 2256 "core/cfg.y"
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); ;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 2260 "core/cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 2261 "core/cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 2277 "core/cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 2293 "core/cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval)); yyerror("invalid hostname"); ;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 2294 "core/cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval)); yyerror("invalid hostname"); ;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 2299 "core/cfg.y"
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval))
				strcpy((yyval.strval), yy_number_str);
		;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 2308 "core/cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); ;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 2309 "core/cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 2325 "core/cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LM_CRIT("cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 2341 "core/cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval));
								yyerror("invalid host or interface name"); ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 2343 "core/cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval));
								yyerror("invalid host or interface name"); ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 2350 "core/cfg.y"
    {
		/* check if allowed */
		if ((yyvsp[(1) - (1)].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[(1) - (1)].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[(1) - (1)].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[(1) - (1)].action);
		}
	;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 2392 "core/cfg.y"
    { (yyval.action)=(yyvsp[(1) - (1)].action); ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 2393 "core/cfg.y"
    { (yyval.action)=(yyvsp[(2) - (3)].action); ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 2396 "core/cfg.y"
    {(yyval.action)=append_action((yyvsp[(1) - (2)].action), (yyvsp[(2) - (2)].action)); ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 2397 "core/cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 2398 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad command"); ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 2401 "core/cfg.y"
    {(yyval.action)=(yyvsp[(1) - (2)].action);;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 2402 "core/cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 2403 "core/cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 2404 "core/cfg.y"
    { (yyval.action)=(yyvsp[(1) - (1)].action); ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 2405 "core/cfg.y"
    { (yyval.action)=(yyvsp[(1) - (2)].action); ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 2406 "core/cfg.y"
    {(yyval.action)=(yyvsp[(1) - (2)].action);;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 2407 "core/cfg.y"
    {(yyval.action)=0;;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 2408 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 2411 "core/cfg.y"
    {
		if ((yyvsp[(2) - (3)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (3)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (3)].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[(2) - (3)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (3)].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 2419 "core/cfg.y"
    {
		if ((yyvsp[(2) - (5)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (5)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (5)].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[(2) - (5)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (5)].action), ACTIONS_ST, (yyvsp[(5) - (5)].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 2429 "core/cfg.y"
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[(1) - (1)].rv_expr) && !rve_is_constant((yyvsp[(1) - (1)].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[(1) - (1)].rv_expr);
		;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 2446 "core/cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(2) - (4)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(2) - (4)].rv_expr), 0, (yyvsp[(4) - (4)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 2453 "core/cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(3) - (5)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(3) - (5)].rv_expr), 1, (yyvsp[(5) - (5)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 2460 "core/cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(2) - (3)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(2) - (3)].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 2467 "core/cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(3) - (4)].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(3) - (4)].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 2474 "core/cfg.y"
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[(3) - (3)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 2479 "core/cfg.y"
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 2484 "core/cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case label"); ;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 2485 "core/cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case regex label"); ;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 2486 "core/cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case label"); ;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 2487 "core/cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case regex label"); ;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 2488 "core/cfg.y"
    { (yyval.case_stms)=0; yyerror ("bad case body"); ;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 2491 "core/cfg.y"
    {
		(yyval.case_stms)=(yyvsp[(1) - (2)].case_stms);
		if ((yyvsp[(2) - (2)].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[(2) - (2)].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 2500 "core/cfg.y"
    {
		(yyval.case_stms)=(yyvsp[(1) - (1)].case_stms);
		if ((yyvsp[(1) - (1)].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 2507 "core/cfg.y"
    {
		(yyval.action)=0;
		if ((yyvsp[(2) - (5)].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[(4) - (5)].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[(4) - (5)].case_stms))!=0){
			yyerror_at(&(yyvsp[(2) - (5)].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[(4) - (5)].case_stms))!=0){
			yyerror_at(&(yyvsp[(2) - (5)].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[(2) - (5)].rv_expr), CASE_ST, (yyvsp[(4) - (5)].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 2532 "core/cfg.y"
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[(2) - (4)].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[(2) - (4)].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 2548 "core/cfg.y"
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); ;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 2550 "core/cfg.y"
    {(yyval.action)=0; yyerror ("bad switch body"); ;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 2554 "core/cfg.y"
    {
		if ((yyvsp[(2) - (3)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (3)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (3)].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[(2) - (3)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (3)].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[(2) - (3)].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 2573 "core/cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (1)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (1)].strval));
		sel.n++;
	;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 2582 "core/cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (4)].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[(3) - (4)].intval);
		sel.n++;
	;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 2594 "core/cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (4)].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(3) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(3) - (4)].strval));
		sel.n++;
	;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 2613 "core/cfg.y"
    { sel.n = 0; sel.f[0] = 0; ;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 2613 "core/cfg.y"
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 2623 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_FROM; ;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 2624 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_TO; ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 2625 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; ;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 2626 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 2627 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 2628 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 2629 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 2630 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 2631 "core/cfg.y"
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 2634 "core/cfg.y"
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[(1) - (1)].strval); s_attr->name.s.len = strlen ((yyvsp[(1) - (1)].strval)); ;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 2641 "core/cfg.y"
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 2648 "core/cfg.y"
    { (yyval.attr) = s_attr; ;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 2651 "core/cfg.y"
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[(4) - (5)].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[(4) - (5)].intval)<0?-(yyvsp[(4) - (5)].intval):(yyvsp[(4) - (5)].intval));
		(yyval.attr) = s_attr;
	;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 2658 "core/cfg.y"
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 2680 "core/cfg.y"
    {
		if ((yyvsp[(1) - (1)].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[(1) - (1)].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[(1) - (1)].lval));
	;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 2692 "core/cfg.y"
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[(1) - (1)].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 2716 "core/cfg.y"
    {
			s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen((yyvsp[(1) - (1)].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[(1) - (1)].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 2727 "core/cfg.y"
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 2758 "core/cfg.y"
    { (yyval.intval) = ASSIGN_T; ;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 2762 "core/cfg.y"
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[(1) - (1)].attr);
					pkg_free((yyvsp[(1) - (1)].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 2772 "core/cfg.y"
    {
					if (!pv_is_w((yyvsp[(1) - (1)].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[(1) - (1)].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[(1) - (1)].pvar);
					(yyval.lval)=lval_tmp;
				;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 2786 "core/cfg.y"
    {
					if (((yyvsp[(1) - (1)].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[(1) - (1)].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[(1) - (1)].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[(1) - (1)].lval);
				;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 2798 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[(1) - (1)].intval)); ;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 2799 "core/cfg.y"
    {	s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen((yyvsp[(1) - (1)].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); ;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 2801 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[(1) - (1)].attr)); pkg_free((yyvsp[(1) - (1)].attr)); ;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 2802 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[(1) - (1)].pvar)); ;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 2803 "core/cfg.y"
    {
							switch((yyvsp[(1) - (1)].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[(1) - (1)].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[(1) - (1)].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[(1) - (1)].lval)); /* not needed anymore */
						;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 2817 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[(1) - (1)].select)); pkg_free((yyvsp[(1) - (1)].select)); ;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 2818 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(1) - (1)].action)); ;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 2819 "core/cfg.y"
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[(1) - (1)].expr)); ;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 2820 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(2) - (3)].action)); ;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 2821 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad command block"); ;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 2822 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(2) - (3)].action)); ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 2823 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 2827 "core/cfg.y"
    { (yyval.intval)=RVE_LNOT_OP; ;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 2828 "core/cfg.y"
    { (yyval.intval)=RVE_BNOT_OP; ;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 2829 "core/cfg.y"
    { (yyval.intval)=RVE_UMINUS_OP; ;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 2842 "core/cfg.y"
    { (yyval.rv_expr)=(yyvsp[(1) - (1)].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 2848 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve1((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].rv_expr)); ;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 2849 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[(2) - (2)].rv_expr)); ;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 2850 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[(2) - (2)].rv_expr)); ;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 2851 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 2852 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 2853 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 2854 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 2855 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 2856 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr)); ;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 2857 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 2858 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 2859 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 2860 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 2861 "core/cfg.y"
    { (yyval.rv_expr)=mk_rve2( (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 2862 "core/cfg.y"
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[(3) - (3)].rv_expr) != NULL && (yyvsp[(3) - (3)].rv_expr)->op==RVE_RVAL_OP && (yyvsp[(3) - (3)].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[(3) - (3)].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[(2) - (3)].intval)==RVE_DIFF_OP || (yyvsp[(2) - (3)].intval)==RVE_IDIFF_OP
						|| (yyvsp[(2) - (3)].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[(1) - (3)].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[(1) - (3)].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[(3) - (3)].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));
			}
		;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 2880 "core/cfg.y"
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 2881 "core/cfg.y"
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 2882 "core/cfg.y"
    { (yyval.rv_expr)=(yyvsp[(2) - (3)].rv_expr);;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 2883 "core/cfg.y"
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[(3) - (4)].rv_expr));;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 2884 "core/cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[(3) - (4)].rv_expr));;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 2885 "core/cfg.y"
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[(2) - (2)].rv_expr));;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 2886 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 2887 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 2888 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 2889 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 2890 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 2891 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 2892 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 2893 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 2894 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 2895 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 2897 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 2899 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 2900 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 2901 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 2902 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 2903 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 2904 "core/cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 2907 "core/cfg.y"
    { (yyval.action)=mk_action((yyvsp[(2) - (3)].intval), 2, LVAL_ST, (yyvsp[(1) - (3)].lval),
														 	  RVE_ST, (yyvsp[(3) - (3)].rv_expr));
											set_cfg_pos((yyval.action));
										;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 2925 "core/cfg.y"
    { (yyval.intval) = 1; ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 2926 "core/cfg.y"
    { (yyval.intval) = 0; ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 2927 "core/cfg.y"
    { (yyval.intval) = -1; ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 2930 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 2931 "core/cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 2932 "core/cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 2933 "core/cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 2934 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 2935 "core/cfg.y"
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 2936 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 2937 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 2938 "core/cfg.y"
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 2939 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 2940 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 2941 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad forward argument"); ;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 2942 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 2943 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 2944 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 2945 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 2946 "core/cfg.y"
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 2947 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 2948 "core/cfg.y"
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 2949 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 2950 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 2951 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 2952 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad forward_udp argument"); ;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 2953 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 2954 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 2955 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 2956 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 2957 "core/cfg.y"
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 2958 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 2959 "core/cfg.y"
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 2960 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 2961 "core/cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 2962 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 2963 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); ;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 2964 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 2972 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 2980 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 2988 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 2996 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 3004 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 3012 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 3020 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 3028 "core/cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 3036 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 3037 "core/cfg.y"
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); ;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 3039 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 3047 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 3055 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 3063 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 3072 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 3081 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 3090 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 3098 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 3107 "core/cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 3115 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 3116 "core/cfg.y"
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); ;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 3118 "core/cfg.y"
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[(3) - (4)].strval));
									set_cfg_pos((yyval.action)); ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 3121 "core/cfg.y"
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[(3) - (6)].intval), STRING_ST, (yyvsp[(5) - (6)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 3122 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 3123 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad log argument"); ;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 3124 "core/cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 3131 "core/cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 3138 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 3139 "core/cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 3145 "core/cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 3152 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 3153 "core/cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 3159 "core/cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 3166 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 3167 "core/cfg.y"
    {
		i_tmp=get_avpflag_no((yyvsp[(5) - (6)].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[(3) - (6)].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[(1) - (6)].intval));
		set_cfg_pos((yyval.action));
	;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 3173 "core/cfg.y"
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 3176 "core/cfg.y"
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 3179 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad parameters"); ;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 3180 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); ;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 3181 "core/cfg.y"
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), STRING_ST, (yyvsp[(5) - (6)].strval));
			set_cfg_pos((yyval.action));
	;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 3184 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 3185 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad error argument"); ;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 3186 "core/cfg.y"
    {
		if ((yyvsp[(3) - (4)].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[(3) - (4)].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 3195 "core/cfg.y"
    {
		if ((yyvsp[(3) - (4)].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[(3) - (4)].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 3204 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 3205 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad route argument"); ;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 3206 "core/cfg.y"
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 3207 "core/cfg.y"
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 3208 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 3209 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 3210 "core/cfg.y"
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 3211 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 3212 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 3213 "core/cfg.y"
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 3214 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 3215 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 3216 "core/cfg.y"
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 3217 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 3218 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 3219 "core/cfg.y"
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 3220 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 3221 "core/cfg.y"
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
			set_cfg_pos((yyval.action));
	;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 3225 "core/cfg.y"
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 3229 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 3230 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 3231 "core/cfg.y"
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 3232 "core/cfg.y"
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 3233 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 3234 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 3235 "core/cfg.y"
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 3236 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 3237 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 3238 "core/cfg.y"
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 3239 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 3240 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 3241 "core/cfg.y"
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 3242 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 3243 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 3244 "core/cfg.y"
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 3245 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 3246 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 3247 "core/cfg.y"
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 3248 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 3249 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 3250 "core/cfg.y"
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 3251 "core/cfg.y"
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 3252 "core/cfg.y"
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 3253 "core/cfg.y"
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 3254 "core/cfg.y"
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 3255 "core/cfg.y"
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); ;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 3256 "core/cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 3264 "core/cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 3272 "core/cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 3280 "core/cfg.y"
    {(yyval.action)=0; yyerror("bad argument, number expected"); ;}
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 3282 "core/cfg.y"
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); ;}
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 3284 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); ;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 3285 "core/cfg.y"
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			str_tmp->s=(yyvsp[(3) - (4)].strval);
			str_tmp->len=(yyvsp[(3) - (4)].strval)?strlen((yyvsp[(3) - (4)].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 3296 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 3297 "core/cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 3298 "core/cfg.y"
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[(3) - (4)].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LM_CRIT("cfg. parser: out of memory.\n");
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				LM_CRIT("cfg. parser: out of memory.\n");
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 3314 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); ;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 3315 "core/cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 3316 "core/cfg.y"
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[(3) - (4)].sockid));
		set_cfg_pos((yyval.action));
	;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 3320 "core/cfg.y"
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 3323 "core/cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 3324 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 3327 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 3330 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 3333 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 3336 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 3339 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 3342 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 3345 "core/cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 3348 "core/cfg.y"
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
	;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 3351 "core/cfg.y"
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), RVE_ST, (yyvsp[(5) - (6)].rv_expr)); set_cfg_pos((yyval.action));
	;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 3354 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 3355 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); ;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 3356 "core/cfg.y"
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action));
	;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 3359 "core/cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 3360 "core/cfg.y"
    { (yyval.action)=0; yyerror("bad arguments, string expected"); ;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 3361 "core/cfg.y"
    {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[(1) - (1)].strval));
			yyerror("use of function execution inside params not allowed\n");
			exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 3368 "core/cfg.y"
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[(1) - (5)].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 3394 "core/cfg.y"
    { yyerror("'('')' expected (function call)");;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 3398 "core/cfg.y"
    { ;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 3399 "core/cfg.y"
    {;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 3402 "core/cfg.y"
    {
		if ((yyvsp[(1) - (1)].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[(1) - (1)].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[(1) - (1)].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 3419 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 3423 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 3427 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 3431 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 3436 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 3440 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 3445 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 3449 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 3453 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 3457 "core/cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	;}
    break;



/* Line 1455 of yacc.c  */
#line 13112 "core/cfg.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 3463 "core/cfg.y"


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		LM_CRIT("cfg. parser: out of memory.\n");
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LM_CRIT("cfg. parser: out of memory.\n");
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LM_CRIT("cfg. parser: out of memory.\n");
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/

